unit AviCutting;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MySource,vfw;

type
  TKFInfo=record
    First,Second:Integer;
  end;
  TAviCutting = class(TComponent)
  private
    { Private declarations }
    FFileName:String;
    FTotalFrame:Integer;
    AError:Integer;
    pavi:PAVIFILE;
    AVIInfo:TAVIFILEINFO;
    AviStream:PAviStream;
    FMemFile1,FMemFile2:String;
  protected
    { Protected declarations }
    function AssignSlash(FString:String):String;
  public
    { Public declarations }
    function Execute:Boolean;
    function GetNearKF(FFrame:Integer):TKFInfo;
    procedure CreateSyl(FBefore,FFirst,FSecond,FFile1,FFile2:String;FKFInfo:TKFInfo);
    function ExecuteSyl(FPath:String):Boolean;
  published
    { Published declarations }
    property FileName:String read FFileName write FFileName;
    property TotalFrame:Integer read FTotalFrame;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Divx4', [TAviCutting]);
end;

function TAviCutting.Execute:Boolean;
begin
  Result:=False;
  if FFileName='' then Exit;
  if not FileExists(FFileName) then Exit;
  AviFileInit;
  AError:=AVIFileOpen(pavi,PChar(FFileName),OF_READ,nil);
  if AError<>0 then begin
    AVIFileExit;
    Exit;
  end;
  AVIFileInfo(pavi,@AviInfo,SizeOf(AviInfo));
  FTotalFrame:=AviInfo.dwLength;
  AError:=AviFileGetStream(pavi,AviStream,streamtypeVIDEO,0);
  if AError<>0 then begin
    AviFileRelease(pavi);
    Exit;
  end;
  AviFileRelease(pavi);
  Result:=True;
end;

function TAviCutting.GetNearKF(FFrame:Integer):TKFInfo;
var
  ATemp1:Integer;
  ATemp2,ATemp3:DWord;
  ATemp5,ATemp4:DWord;
begin
  Result.First:=-1;
  Result.Second:=-1;
  AviFileInit;
  AError:=AVIFileOpen(pavi,PChar(FFileName),OF_READ,nil);
  if AError<>0 then begin
    AVIFileExit;
    Exit;
  end;
  AVIFileInfo(pavi,@AviInfo,SizeOf(AviInfo));
  AError:=AviFileGetStream(pavi,AviStream,streamtypeVIDEO,0);
  if AError<>0 then begin
    AviFileRelease(pavi);
    Exit;
  end;
  ATemp1:=AviStreamPrevKeyFrame(AviStream,FFrame);
  ATemp2:=AviStreamSampleToTime(AviStream,ATemp1);
  ATemp3:=AviStreamSampleToTime(AviStream,AviInfo.dwLength);
  ATemp4:=ATemp3-ATemp2; // For the Beginning to KeyFrame...
  ATemp5:=ATemp2; // for the Middle to the end...
  AviFileRelease(pavi);
  Result.First:=ATemp4;
  Result.Second:=ATemp5;
end;

function TAviCutting.AssignSlash(FString:String):String;
var
  i1:Integer;
  FType:String;
begin
  FType:='';
  for i1:=1 to Length(FString) do begin
    FType:=FType+Copy(FString,i1,1);
    if Copy(FString,i1,1)='\' then FType:=FType+'\';
  end;
  Result:=FType;
//  ShowMessage(Format('[%s][%s]',[FString,FType]));
end;

procedure TAviCutting.CreateSyl(FBefore,FFirst,FSecond,FFile1,FFile2:String;FKFInfo:TKFInfo);
var
  AList:TStringList;
begin
  FMemFile1:=FFile1;
  FMemFile2:=FFile2;
  AList:=TStringList.Create;
  with AList do begin
    Clear;
    Add(Format('VirtualDub.Open("%s",1,0);',[AssignSlash(FBefore)]));
    Add('VirtualDub.video.SetMode(0);');
    Add(Format('VirtualDub.video.SetRange(0,%d);',[FKFInfo.First]));
    Add(Format('VirtualDub.SaveAVI("%s");',[AssignSlash(FFirst)]));
    SaveToFile(FFile1);
  end;
  with AList do begin
    Clear;
    Add(Format('VirtualDub.Open("%s",1,0);',[AssignSlash(FBefore)]));
    Add('VirtualDub.video.SetMode(0);');
    Add(Format('VirtualDub.video.SetRange(%d,1);',[FKFInfo.Second]));
    Add(Format('VirtualDub.SaveAVI("%s");',[AssignSlash(FSecond)]));
    SaveToFile(FFile2);
  end;
  AList.Free;
end;

function TAviCutting.ExecuteSyl(FPath:String):Boolean;
begin
  MyShellExecute(SlashSep(FPath,'VirtualDub.exe'),Format('/s"%s" /x /r',[FMemFile1]));
  MyShellExecute(SlashSep(FPath,'VirtualDub.exe'),Format('/s"%s" /x /r',[FMemFile2]));
  Result:=True;
end;



end.
