unit BeforeImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TBeforeImage = class(TImage)
  private
    { Private declarations }
  protected
    { Protected declarations }
    function GetRight:Integer;
    procedure SetRight(FRight:Integer);
    function GetBottom:Integer;
    procedure SetBottom(FBottom:Integer);
    function GetWMiddle:Integer;
    procedure SetWMiddle(FWMiddle:Integer);
    function GetHMiddle:Integer;
    procedure SetHMiddle(FHMiddle:Integer);
  public
    { Public declarations }
    DeltaX,DeltaY,WMin,WMax,HMin,HMax:Integer;
    ClientLeft,ClientTop,ClientRight,ClientBottom:Integer;
    MaxTimer,Timer:Integer;
    Vitesse:Boolean;
    VitesseTimer,VitesseMaxTimer:Integer;
    Invisible,MaxInvisible:Integer;
    OnTimer:Boolean;
    OnTimerX,OnTimerY,OnMaxTimer:Integer;
    OnSombre:Boolean;
    OnMaxSombre:Integer;
    OnReduit,OnGrandit:Boolean;
    OnMaxReduit,OnMaxGrandit:Integer;
    OnParalyse:Boolean;
    OnMaxParalyse:Integer;
    OnDisparait:Boolean;
    OnMaxDisparait:Integer;
    OnBarre:Boolean;
    OnMaxBarre:Integer;
    OnMask:Boolean;
    OnMaxMask:Integer;
    Dx,Dy:Double;
    Memx,Memy:Double;
    LastX,LastY:Integer;
  public
    procedure SetClient(left,top,right,bottom:Integer);overload;
    function Inflate(hori,verti:Integer):TRect;
    procedure Clear;
    procedure SetClient(client:TRect);overload;
  published
    { Published declarations }
    property Right:Integer read GetRight write SetRight;
    property Bottom:Integer read GetBottom write SetBottom;
    property WMiddle:Integer read GetWMiddle write SetWMiddle;
    property HMiddle:Integer read GetHMiddle write SetHMiddle;
  end;

procedure Register;

implementation

function TBeforeImage.GetRight:Integer;
begin
  Result:=Left+Width;
end;

procedure TBeforeImage.SetRight(FRight:Integer);
begin
  Left:=FRight-Width;
end;

function TBeforeImage.GetBottom:Integer;
begin
  Result:=Top+Height;
end;

procedure TBeforeImage.SetBottom(FBottom:Integer);
begin
  Top:=FBottom-Height;
end;

function TBeforeImage.GetWMiddle:Integer;
begin
  Result:=Left+(Width div 2);
end;

procedure TBeforeImage.SetWMiddle(FWMiddle:Integer);
begin
  Left:=FWMiddle-(Width div 2);
end;

function TBeforeImage.GetHMiddle:Integer;
begin
  Result:=Top+(Height div 2);
end;

procedure TBeforeImage.SetHMiddle(FHMiddle:Integer);
begin
  Top:=FHMiddle-(Height div 2);
end;

function TBeforeImage.Inflate(hori,verti:Integer):TRect;
var
  NewRect,OldRect:TRect;
begin
  OldRect:=Canvas.ClipRect;
  NewRect.Left:=OldRect.Left+hori;
  NewRect.Top:=OldRect.Top+verti;
  NewRect.Right:=OldRect.Right-hori;
  NewRect.Bottom:=OldRect.Bottom-verti;
  Result:=NewRect;
end;

procedure TBeforeImage.SetClient(left,top,right,bottom:Integer);
begin
  ClientLeft:=left;
  ClientTop:=top;
  ClientRight:=right;
  ClientBottom:=bottom;
end;

procedure TBeforeImage.Clear;
begin
  VitesseTimer:=0;
  VitesseMaxTimer:=0;
  Vitesse:=False;
  MaxTimer:=0;
  Timer:=0;
  Invisible:=0;
  MaxInvisible:=0;
  OnTimer:=False;
  OnTimerX:=0;
  OnTimerY:=0;
  OnMaxTimer:=0;
  OnSombre:=False;
  OnMaxSombre:=0;
  OnReduit:=False;
  OnMaxReduit:=0;
  OnGrandit:=False;
  OnMaxGrandit:=0;
  OnParalyse:=False;
  OnMaxParalyse:=0;
  OnDisparait:=False;
  OnMaxDisparait:=0;
  OnBarre:=False;
  OnMaxBarre:=0;
  OnMask:=False;
  OnMaxMask:=0;
end;

procedure TBeforeImage.SetClient(client:TRect);
begin
  Left:=client.Left;
  Top:=client.Top;
  Width:=client.Right-Left;
  Height:=client.Bottom-Top;
end;


procedure Register;
begin
  RegisterComponents('MyControl1', [TBeforeImage]);
end;

end.
