// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DosOutPut.pas' rev: 5.00

#ifndef DosOutPutHPP
#define DosOutPutHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dosoutput
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TPriorityClass { pcDefault, pcIdle, pcNormal, pcHigh, pcRealtime };
#pragma option pop

class DELPHICLASS TOuputDos;
typedef void __fastcall (__closure *TDataEvent)(TOuputDos* Sender, void * Buffer, int Size);

struct TPipeError
{
	unsigned hRead;
	unsigned hWrite;
} ;

class PASCALIMPLEMENTATION TOuputDos : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	int FAvailable;
	void __fastcall ProcessTerminated(void);
	
protected:
	_PROCESS_INFORMATION FProcessInfo;
	int FExitCode;
	AnsiString FExecutable;
	AnsiString FCommandline;
	bool FDefaultErrorMode;
	Classes::TThread* FThread;
	bool FStartSuspended;
	bool FKillOnDestroy;
	AnsiString FDirectory;
	void *FEnvironment;
	TPriorityClass FInitialPriority;
	TPipeError FPipeInput;
	TPipeError FPipeOutput;
	TPipeError FPipeError;
	TDataEvent FOnData;
	TDataEvent FOnErrorData;
	Classes::TNotifyEvent FOnTerminated;
	int FShowWindow;
	void __fastcall Error(AnsiString msg);
	void __fastcall WinError(AnsiString msg);
	void __fastcall CreatePipes(void);
	void __fastcall ClosePipes(void);
	bool __fastcall GetRunning(void);
	int __fastcall GetExitCode(void);
	int __fastcall GetProcessID(void);
	int __fastcall GetThreadID(void);
	int __fastcall GetProcessHandle(void);
	void __fastcall SetShowWindow(int Value);
	int __fastcall GetThreadHandle(void);
	void __fastcall SetExecutable(AnsiString Value);
	AnsiString __fastcall GetCommandLine();
	void __fastcall SetCommandLine(AnsiString Value);
	void __fastcall SetDefaultErrorMode(bool Value);
	void __fastcall SetStartSuspended(bool Value);
	void __fastcall SetInitialPriority(TPriorityClass Value);
	void __fastcall SetDirectory(AnsiString Value);
	void __fastcall SetEnvironment(void * Value);
	__property int ProcessHandle = {read=GetProcessHandle, nodefault};
	__property int ThreadHandle = {read=GetThreadHandle, nodefault};
	
public:
	bool IsSuspend;
	__fastcall virtual ~TOuputDos(void);
	void __fastcall Terminate(int dwExitCode);
	void __fastcall Execute(void);
	void __fastcall SendData(void * Buffer, int BufferSize);
	AnsiString __fastcall GetLine(void * Buffer, int BufferSize);
	void __fastcall SendText(AnsiString s);
	void __fastcall Prepare(void);
	void __fastcall Suspend(void);
	void __fastcall Resume(void);
	void __fastcall DoUpDate(void);
	__property bool Running = {read=GetRunning, nodefault};
	__property int ExitCode = {read=GetExitCode, nodefault};
	__property int ProcessID = {read=GetProcessID, nodefault};
	__property int ThreadID = {read=GetThreadID, nodefault};
	__property void * Environment = {read=FEnvironment, write=SetEnvironment};
	void __fastcall ReadStdOutput(void);
	void __fastcall ReadStdError(void);
	
__published:
	__property bool KillOnDestroy = {read=FKillOnDestroy, write=FKillOnDestroy, nodefault};
	__property AnsiString Executable = {read=FExecutable, write=SetExecutable};
	__property AnsiString CommandLine = {read=GetCommandLine, write=SetCommandLine};
	__property int ShowWindow = {read=FShowWindow, write=SetShowWindow, default=10};
	__property bool DefaultErrorMode = {read=FDefaultErrorMode, write=SetDefaultErrorMode, nodefault};
	__property bool StartSuspended = {read=FStartSuspended, write=SetStartSuspended, nodefault};
	__property TPriorityClass InitialPriority = {read=FInitialPriority, write=SetInitialPriority, nodefault
		};
	__property AnsiString Directory = {read=FDirectory, write=SetDirectory};
	__property TDataEvent OnData = {read=FOnData, write=FOnData};
	__property TDataEvent OnErrorData = {read=FOnErrorData, write=FOnErrorData};
	__property Classes::TNotifyEvent OnTerminated = {read=FOnTerminated, write=FOnTerminated};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TOuputDos(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Dosoutput */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Dosoutput;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DosOutPut
