unit FolderBrowse;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Shlobj,FileCtrl,MySource;


const
    CM_NEW=1000;


type
  TFolderBrowse = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
    procedure SetDirectory(directory:String);
    procedure SetCaption(caption:String);
    procedure SetCreate(create:Boolean);
  public
    { Public declarations }
    FDirectory:String;
    FCreate:Boolean;
    FCaption,FText:String;
    BOwner:TComponent;
  public
    constructor Create(AOwner:TComponent);override;
    function Execute:Boolean;
    function SelectDir(Parent:HWND):Boolean;
  published
    { Published declarations }
    property Directory:String read FDirectory write SetDirectory;
    property Change:Boolean read FCreate write SetCreate;
    property Caption:String read FCaption write SetCaption;
    property Text:String read FText write FText;
end;
var
   WND_NEWBT:HWND;
   ItemID:PITEMIDLIST;
   DisplayName:array[0..MAX_PATH] of char;
   NewOne:Boolean;
   NewFolder,Current,InterneCaption:String;

function BrowseMessage(HWindow:HWND;uMsg:UINT;lParameter,lpBrowseFolder:LPARAM):Integer;stdcall;
procedure AddNewButton(wnd:HWND);
function OwnWNDProc(wnd:HWND;Msg:UINT;wParam:WPARAM;lParam:LPARAM):LRESULT;stdcall;
function CmCreateDirectory(wnd:HWND):Boolean;

procedure Register;

implementation

constructor TFolderBrowse.Create(AOwner:TComponent);
begin
    inherited Create(AOwner);
    FDirectory:='';
    Current:='';
    FText:='Select a Directory';
    FCaption:='Browse for folder';
    FCreate:=True;
    BOwner:=AOwner;
end;
function TFolderBrowse.Execute:Boolean;
var
   iBrowse:TBROWSEINFO;
   ItemID:PITEMIDLIST;
   GDir:PChar;
begin
    if FCreate then
    begin
        NewOne:=True;
        while NewOne do
        begin
             NewOne:=false;
             SelectDir(0);
        end;
        FDirectory:=Current;
        if FDirectory<>'' then
        begin
             Result:=True;
             Exit;
        end;
        Result:=False;
        Exit;
     end
     else
     begin
         GetMem(GDir,MAX_PATH);
         iBrowse.hwndOwner:=Application.Handle;
         iBrowse.pidlRoot:=NIL;
         iBrowse.pszDisplayName:=DisplayName;
         iBrowse.lpszTitle:=PChar(FText);
         iBrowse.ulFlags:=1;
         iBrowse.lParam:=0;
         iBrowse.lpfn:=NIL;

         ItemID:=SHBrowseForFolder(iBrowse);
         SHGetPathFromIDList(ItemID, GDir);
         GlobalFreePtr(ItemID);
         FDirectory:='';
         FDirectory:=GDir;
         if FDirectory<>'' then
         begin
             Result:=True;
             Exit;
         end;
         Result:=False;
         Exit;
     end;
end;
function TFolderBrowse.SelectDir(Parent:HWND):Boolean;
var
     iBrowse:TBrowseInfo;
     ItemID:PITEMIDLIST;
     GDir:PChar;
begin
     GetMem(GDir,MAX_PATH);
     iBrowse.hwndOwner:=Application.Handle;
     iBrowse.pidlRoot:=NIL;
     iBrowse.pszDisplayName:=DisplayName;
     iBrowse.lpszTitle:=PChar(FText);
     iBrowse.ulFlags:=1;
     iBrowse.lpfn:=@BrowseMessage;
     iBrowse.lParam:=0;

     ItemID:=SHBrowseForFolder(iBrowse);
     SHGetPathFromIDList(ItemID, GDir);
     GlobalFreePtr(ItemID);

     Current:='';
     Current:=GDir;
     if NewOne then
     begin
         Current:=SlashSep(Current,NewFolder);
         if not ForceDirectories(Current) then
         begin
              NewOne:=False;
              Current:='';
         end;
     end;
     Result:=True;
end;
procedure TFolderBrowse.SetDirectory(directory:String);
begin
     if (not DirectoryExists(directory)) and (directory<>'') then
     begin
          MessageDlg('The Directory '+directory+' doesn\''t exist!',
                     mtError,[mbOK],0);
          FDirectory:='';
          Exit;
     end;
     Current:=directory;
     FDirectory:=Current;
end;
procedure TFolderBrowse.SetCaption(caption:String);
begin
     FCaption:=caption;
     InterneCaption:=caption;
end;
procedure TFolderBrowse.SetCreate(create:Boolean);
begin
     FCreate:=create;
end;

function BrowseMessage(HWindow:HWND;uMsg:UINT;lParameter,lpBrowseFolder:LPARAM):Integer;stdcall;
begin
     Result := 0;
	case uMsg of
		1{BFFM_INITIALIZED}:begin
                      if Current<>'' then SendMessage(HWindow,BFFM_SETSELECTION,1,Integer(Current));
                      AddNewButton ( HWindow );
                end;

		2{BFFM_SELCHANGED}:
			begin
                             // test if the currently selected path is a valid file-system path
                             if not SHGetPathFromIDList ( PItemIDList ( lParameter ) , DisplayName )
                             then
                                 EnableWindow ( GetDlgItem ( HWindow , ID_OK ) , False );

                             // enable new-button only if ok-button is enabled
                             EnableWindow ( WND_NEWBT , IsWindowEnabled ( GetDlgItem ( HWindow , ID_OK )));
			end;
	end;
end;
procedure AddNewButton ( wnd:HWND);
var
  tempwnd:hwnd;                   //hwnd for the child-windows of the dialog
  x1,y1,h1:integer;               //left,top,height of the button

  rct : trect;                    //storage for the ok-button's rect
  tp : tpoint;                    //point for screentoclient-api
begin
        //get the top, left and height of the ok-button

        SetWindowText( wnd ,PChar(InterneCaption));
        tempwnd := GetDlgItem ( wnd , 1 ) ; //ok-button

        getwindowrect (tempwnd,rct);
        tp.x := rct.left;
        tp.y := rct.top;
        screentoclient(wnd,tp);
        x1 := tp.x-90; // our button's width is 75, so this should a bit bigger
        y1 := tp.y;
        h1 := rct.bottom-rct.top;

        //end of position-detection


        WND_NEWBT:=CreateWindow('BUTTON','Create',
        WS_CHILD or WS_CLIPSIBLINGS or WS_VISIBLE or WS_TABSTOP or BS_PUSHBUTTON,
        x1,y1,75,h1,wnd,CM_NEW,HInstance,nil);

        // get the ok-button's font and set it for our button
        PostMessage(WND_NEWBT,WM_SETFONT,SendMessage ( tempwnd , WM_GETFONT , 0 , 0 ) ,MAKELPARAM(1,0));

        // default -> disable, since we are on "my computer"
        EnableWindow ( WND_NEWBT , False );

        //hook a new window procedure to catch this button
	SetWindowLong( wnd , GWL_WNDPROC , Longint(@OwnWNDProc) );
end;
function OwnWndProc( wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
     Result := 1;
     if (Msg=WM_COMMAND) and (wParam=CM_NEW)
     then begin
          if CmCreateDirectory(WND) then
              PostMessage ( wnd , WM_COMMAND , 1  , 0)
     end
     else
         Result := DefDlgProc( wnd,Msg,wParam,lParam);
end;
function CmCreateDirectory(wnd:HWND):Boolean;
begin
     NewOne:=True;
     NewFolder:='';
     if InputQuery('New directory','Please, insert the new sub directory',NewFolder) then
     begin
        if NewFolder<>'' then
        begin
            Result:=True;
            Exit;
        end;
        Result:=False;
        Exit;
     end;
     Result:=False;
end;




procedure Register;
begin
  RegisterComponents('MyControl1', [TFolderBrowse]);
end;

end.
