unit Full;


{*******************************************************}
{       TFull                                           }
{                                                       }
{       Couturiaux Private Library                      }
{       Copyright (c) 1999,2000 Couturiaux Martial      }
{                                                       }
{*******************************************************/

{
    The SubStrings Fonction works like that:
    SubStrings[int index1][int index2];
    where
        index1 = The Column
        index2 = The Row
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MySource;

type
  TSort = (SSAlpha,SSNumeric);
  TSens = (Normal,Reverse);


type
  TFull = class(TComponent)
  private
    { Private declarations }
    function GetSubStrings(index1,index2:Integer):String;
    procedure SetSubStrings(index1,index2:Integer;chaine:String);
    function GetAllLine(index1:Integer):String;
    function GetStrings(index1:Integer):String;
    procedure SetStrings(index1:Integer;chaine:String);
    function GetP(index1:Integer):TStringList;
    procedure SetP(index1:Integer;list1:TStringList);
    function GetSortType:TSort;
    procedure SetSortType(type1:TSort); {Move from type to type1}
    procedure MySortingNumeric(index1:Integer;only:Boolean);
    procedure MySortingAlpha(index1:Integer;only:Boolean);
    procedure MySort1(l,r,listp:Integer;only:Boolean);
    procedure MySort2(l,r,listp:Integer;only:Boolean);
    procedure ExchangeAll(index1,index2,listp:Integer);
    function GetCount:Integer;
    procedure SetColumn(index1:Integer);
    procedure CmVerifie;
    function GetMaxString(index1:Integer):Integer;
    procedure CmFillEmpty(index1:Integer);
    procedure CmKillEmpty(index1:Integer);
    function GetSubCount(index1:Integer):Integer;
  private
    FColumn,Items:Integer;
    FSepa:String;
    FSortType:TSort;
    Sens:TSens;
    List:array[0..101] of TStringList;
    ListTemp1,ListTemp2,ListSort:TStringList;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure Clear(Column:Integer);overload;
    procedure Clear;overload;
    procedure Add(chaine:String);overload;
    procedure Add(chaine:Integer);overload;
    procedure Sort(index1:Integer;only:Boolean);overload;
    procedure Sort;overload;
    procedure Sort(index1:Integer);overload;
    procedure ReverseSort(index1:Integer;only:Boolean);overload;
    procedure ReverseSort;overload;
    procedure ReverseSort(index1:Integer);overload;
    procedure SwapList(index1,index2:Integer);
    procedure Delete(index1:Integer);
    procedure Exchange(index1,index2:Integer);
    function Find(chaine:String;index1:Integer):Boolean;  {Verify the &index1}
    procedure AddObject(chaine:String;object1:TObject);
    procedure Insert(index1:Integer;chaine:String);
    procedure InsertAll(index1:Integer);
    procedure AddStrings(list1:TStrings;index1:Integer);overload;
    procedure AddStrings(list1:TStringList;index1:Integer);overload;
    procedure AddStrings(list1:TFull;index1:Integer);overload;
    procedure AddStrings(list1:TStrings);overload;
    procedure AddStrings(list1:TStringList);overload;
    procedure AddStrings(list1:TFull);overload;
    procedure LoadFromFile(chaine:String);
    procedure LoadAndClear(chaine:String);overload;
    procedure Load;
    procedure LoadAndClear;overload;
    procedure SaveToFile(chaine:String);
    procedure SaveAndClear(chaine:String);overload;
    procedure Save;
    procedure SaveAndClear;overload;
    procedure LoadTotal(chaine:String);overload;
    procedure LoadTotal;overload;
    procedure SaveTotal(chaine:String);overload;
    procedure SaveTotal;overload;
    function IndexOf(chaine:String;index1:Integer):Integer;overload;
    function IndexOf(chaine:String):integer;overload;
    procedure ClearEmpty(column:Integer);overload;
    procedure ClearEmpty;overload;
    procedure Update;
    function ShowAllLine(Index:Integer):String;
    procedure SetItems(FCount:Integer);
    procedure ReadFiles(ParentFile:String;Include:Boolean);overload;
    procedure ReadFiles(ParentFile:String);overload;
    procedure ReadDirectory(ParentDirectory:String);
    procedure ReadOnlyDirectory(ParentDirectory:String);
    procedure ReadOnlyFiles(ParentFile:String;Include:Boolean);overload;
    procedure ReadOnlyFiles(ParentFile:String);overload;
  public
    Name:String;
    dir:FILE;
  public
    property SubStrings[index1:Integer;index2:Integer]:String read GetSubStrings write SetSubStrings;
    property AllLine[index1:Integer]:String read GetAllLine;
    property Strings[index1:Integer]:String read GetStrings write SetStrings;
    property P[index1:Integer]:TStringList read GetP write SetP;
    property SortType:TSort read GetSortType write SetSortType;
    property Count:Integer read GetCount;
    property SubCount[index1:Integer]:Integer read GetSubCount;
    property Column:Integer read FColumn write SetColumn;
    property MaxStrings[index1:Integer]:Integer read GetMaxString;
  published
    { Published declarations }
    property Sepa:AnsiString read FSepa write FSepa;
  end;

procedure Register;

implementation

{TFull Procedure and function}


constructor TFull.Create(AOwner:TComponent);
var
  i1:Integer;
begin
  inherited Create(AOwner);
  Items:=10;
  for i1:=0 to 10 do begin
    List[i1]:=TStringList.Create;
  end;
  CmVerifie;
  FSepa:='<SEPA>';
  Name:='';
  FSortType:=SSAlpha;
  ListTemp1:=TStringList.Create;
  ListTemp2:=TStringList.Create;
  ListSort:=TStringList.Create;
  FColumn:=10;
end;

destructor TFull.Destroy;
var
  i1:Integer;
begin
  for i1:=0 to Items do begin
    List[i1].Free;
  end;
  ListTemp1.Free;
  ListTemp2.Free;
  ListSort.Free;
  inherited;
end;

procedure TFull.Clear(Column:Integer);
var
  i1:Integer;
begin
  try
    if Column=-1 then begin
      for i1:=0 to Items do begin
        List[i1].Clear;
      end;
      Exit;
    end;
    List[Column].Clear;
    CmVerifie;
  except
  end;
end;

procedure TFull.Clear;
begin
  Clear(-1);
end;

procedure TFull.Add(chaine:String);
begin
  List[0].Add(chaine);
  CmVerifie;
end;

procedure TFull.Add(chaine:Integer);
begin
  Add(IntToStr(chaine));
end;

procedure TFull.Sort;
begin
  Sort(0,False);
end;

procedure TFull.Sort(index1:Integer);
begin
  Sort(index1,False);
end;


procedure TFull.Sort(index1:Integer;only:Boolean);
begin
  if List[index1].Count=0 then Exit;
  Sens:=Normal;
  case FSortType of
    SSNumeric:MySortingNumeric(index1,only);
    SSAlpha:begin
      CmFillEmpty(index1);
      MySortingAlpha(index1,only);
      CmKillEmpty(index1);
    end;
  end;
end;

procedure TFull.ReverseSort;
begin
  ReverseSort(0,False);
end;

procedure TFull.ReverseSort(index1:Integer);
begin
  ReverseSort(index1,False);
end;


procedure TFull.ReverseSort(index1:Integer;only:Boolean);
begin
  Sens:=Reverse;
  case FSortType of
    SSNumeric:MySortingNumeric(index1,only);
    SSAlpha:MySortingAlpha(index1,only);
  end;
end;

procedure TFull.SwapList(index1,index2:Integer);
begin
  ListTemp1.Clear;
  ListTemp1.AddStrings(P[index1]);
  ListTemp2.Clear;
  ListTemp2.AddStrings(P[index2]);
  P[index1]:= ListTemp2;
  P[index2]:= ListTemp1;
end;

procedure TFull.Delete(index1:Integer);
var
  i1:Integer;
begin
  for i1:=0 to Items do List[i1].Delete(index1);
end;

procedure TFull.Exchange(index1,index2:Integer);
var
  Current1,Current2:String;
begin
  Current1:=List[0].Strings[index1];
  Current2:=List[0].Strings[index2];
  List[0].Strings[index1]:=Current2;
  List[0].Strings[index2]:=Current1;
end;

function TFull.Find(chaine:String;index1:Integer):Boolean;  {Verify the &index1}
begin
  Result:=List[0].Find(chaine,index1);
end;

procedure TFull.AddObject(chaine:String;object1:TObject);
begin
  List[0].AddObject(chaine,object1);
  CmVerifie;
end;

procedure TFull.Insert(index1:Integer;chaine:String);
begin
  List[0].Insert(index1,chaine);
  CmVerifie;
end;

procedure TFull.InsertAll(index1:Integer);
var
  i1:Integer;
begin
  for i1:=0 to Items do List[i1].Insert(index1,'');
end;

procedure TFull.AddStrings(list1:TStrings;index1:Integer);
begin
  ListTemp1.Clear;
  ListTemp1.AddStrings(list1);
  AddStrings(ListTemp1,index1);
end;

procedure TFull.AddStrings(list1:TStrings);
begin
  AddStrings(list1,0);
end;

procedure TFull.AddStrings(list1:TStringList);
begin
  AddStrings(list1,0);
end;

procedure TFull.AddStrings(list1:TFull);
begin
  AddStrings(list1,0);
end;

procedure TFull.AddStrings(list1:TStringList;index1:Integer);
begin
  List[index1].AddStrings(list1);
  CmVerifie;
end;

procedure TFull.AddStrings(list1:TFull;index1:Integer);
begin
  AddStrings(list1.P[0],index1);
end;

procedure TFull.LoadFromFile(chaine:String);
begin
  List[0].LoadFromFile(chaine);
  CmVerifie;
end;

procedure TFull.LoadAndClear(chaine:String);
begin
  Clear;
  LoadFromFile(chaine);
end;

procedure TFull.Load;
begin
  if Name='' then Exit;
  LoadFromFile(Name);
end;

procedure TFull.LoadAndClear;
begin
  if Name='' then Exit;
  Clear;
  Load;
end;

procedure TFull.SaveToFile(chaine:String);
begin
  List[0].SaveToFile(chaine);
end;

procedure TFull.SaveAndClear(chaine:String);
begin
  List[0].SaveToFile(chaine);
  Clear;
end;

procedure TFull.Save;
begin
  if Name='' then Exit;
  SaveToFile(Name);
end;

procedure TFull.SaveAndClear;
begin
  if Name='' then Exit;
  SaveToFile(Name);
  Clear;
end;

procedure TFull.LoadTotal(chaine:String);
var
  i1,i2:Integer;
  ANumberInList,ANumberOfItems:Integer;
  AString:String;
begin
  Clear;
  ListTemp1.Clear;
  ListTemp1.LoadFromFile(chaine);
  ANumberInList:=StrToInt(UmLine(1,ListTemp1.Strings[0]));
  ANumberOfItems:=StrToInt(UmLine(2,ListTemp1.Strings[0]));
  ListTemp1.Delete(0);
  for i1:=0 to ANumberInList-1 do begin
    for i2:=0 to ANumberOfItems do begin
      AString:=UmLine(i2+1,ListTemp1.Strings[i1]);
      List[i2].Add(AString);
    end;
  end;
  CmVerifie;
end;

procedure TFull.LoadTotal;
begin
  if Name='' then Exit;
  LoadTotal(Name);
end;

procedure TFull.SaveTotal(chaine:String);
var
  i1,i2:Integer;
  AString:String;
begin
  ListTemp1.Clear;
  ListTemp1.Add(Format('%d*%d',[List[0].Count,Items]));
  for i1:=0 to Items do begin
    AString:='';
    for i2:=0 to List[i1].Count-1 do begin
      AString:=AString+List[i2].Strings[i1]+'*';
    end;
    AString:=Copy(AString,1,Length(AString)-1);
    ListTemp1.Add(AString);
  end;
  ListTemp1.SaveToFile(chaine);
end;

procedure TFull.SaveTotal;
begin
  if Name='' then Exit;
  SaveTotal(Name);
end;

function TFull.IndexOf(chaine:String):Integer;
begin
  Result:=IndexOf(chaine,0);
end;

function TFull.IndexOf(chaine:String;index1:Integer):Integer;
begin
  Result:=List[index1].IndexOf(chaine);
end;

procedure TFull.ClearEmpty;
begin
  ClearEmpty(-1);
end;


procedure TFull.ClearEmpty(column:Integer);
var
  i1,i2:Integer;
  Current1:String;
begin
  ListTemp1.Clear;
  CmVerifie;
  if column=-1 then begin
   i1:=0;
   while i1<=List[0].Count-1 do begin
     Current1:='';
     for i2:=0 to Items do begin
       Current1:=Current1 + List[i2].Strings[i1];
     end;
     if Current1='' then begin
       Delete(i1);
       i1:=i1-1;
       if i1<0 then i1:=0;
     end;
   end;
  end;
  if column<>-1 then begin
    i1:=0;
    while i1<=List[column].Count-1 do begin
      if List[column].Strings[i1]='' then begin
        List[column].Delete(i1);
        i1:=i1-1;
        if i1<0 then i1:=0;
      end;
    end;
  end;
  CmVerifie;
end;

function TFull.GetSubStrings(index1,index2:Integer):String;
begin
  if index1>Items then begin
    Result:='';
    Exit;
  end;
  if index2=-1 then index2:=Count-1;
  Result:=List[index1].Strings[index2];
end;

procedure TFull.SetSubStrings(index1,index2:Integer;chaine:String);
begin
  while index1>Items do begin
    Items:=Items+1;
    List[Items]:=TStringList.Create;
    CmVerifie;
  end;
  if index2=-1 then begin
    index2:=Count-1;
{        Pos:=-1;
        for i1:=0 to List[index1].Count-1 do
        begin
            if (List[index1].Strings[i1]='') and (Pos=-1) then Pos:=i1;
        end;
        if Pos=-1 then
        begin
            List[0].Add('');
            index2:=List[0].Count-1;
            CmVerifie;
        end
        else index2:=Pos;}
  end;
  List[index1].Strings[index2]:= chaine;
end;

function TFull.GetAllLine(index1:Integer):String;
var
  i1:Integer;
begin
  Result:='';
  for i1:=0 to Items do begin
    Result:=Result+FSepa+List[i1].Strings[index1];
  end;
end;

function TFull.GetStrings(index1:Integer):String;
begin
  Result:=List[0].Strings[index1];
end;

procedure TFull.SetStrings(index1:Integer;chaine:String);
begin
  List[0].Strings[Index1]:=chaine;
end;

function TFull.GetP(index1:Integer):TStringList;
begin
  Result:=List[index1];
end;

procedure TFull.SetP(index1:Integer;list1:TStringList);
begin
  if index1>Items then FColumn:=index1;
  List[index1].Clear;
  List[index1].AddStrings(list1);
  CmVerifie;
end;

function TFull.GetSortType:TSort;
begin
  Result:=FSortType;
end;

procedure TFull.SetSortType(type1:TSort); {Move from type to type1}
begin
  FSortType:=type1;
end;

procedure TFull.MySortingNumeric(index1:Integer;only:Boolean);
begin
  MySort2(0,List[index1].Count-1,index1,only);
end;

procedure TFull.MySortingAlpha(index1:Integer;only:Boolean);
begin
  MySort1(0,List[index1].Count-1,index1,only);
end;

procedure TFull.MySort1(l,r,listp:Integer;only:Boolean);
var
  i,j:Integer;
  x:String;
begin
  i:= l;
  j:= r;
  x:= List[listp].Strings[(l+r) div 2];
  while i<=j do begin
    if Sens=Normal then begin
      while List[listp].Strings[i]<x do i:=i+1;
      while List[listp].Strings[j]>x do j:=j-1;
    end;
    if Sens=Reverse then begin
      while List[listp].Strings[i]>x do i:=i+1;
      while List[listp].Strings[j]<x do j:=j-1;
    end;
    if i<=j then begin
      if not only then ExchangeAll(i,j,listp)
      else List[listp].Exchange(i,j);
      i:=i+1;
      j:=j-1;
    end;
  end;
  if l < j then MySort1(l, j,listp,only);
  if i < r then MySort1(i, r,listp,only);
end;

procedure TFull.MySort2(l,r,listp:Integer;only:Boolean);
var
  i,j,x:Integer;
begin
  i:=l;
  j:=r;
  x:=StrToIntDef(List[listp].Strings[(l+r) div 2],0);
  while i<=j do begin
    if Sens=Normal then begin
      while StrToIntDef(List[listp].Strings[i],0)<x do i:=i+1;
      while x<StrToIntDef(List[listp].Strings[j],0) do j:=j-1;
    end;
    if Sens=Reverse then begin
      while StrToIntDef(List[listp].Strings[i],0)>x do i:=i+1;
      while x>StrToIntDef(List[listp].Strings[j],0) do j:=j-1;
    end;
    if i<=j then begin
      if not only then ExchangeAll(i,j,listp)
      else List[listp].Exchange(i,j);
      i:=i+1;
      j:=j-1;
    end;
  end;
  if l<j then MySort2(l, j,listp,only);
  if i<r then MySort2(i, r,listp,only);
end;

procedure TFull.ExchangeAll(index1,index2,listp:Integer);
var
  i1:Integer;
  Chaine1,Chaine2:String;
begin
  for i1:=0 to Items do begin
    Chaine1:=List[i1].Strings[index1];
    Chaine2:=List[i1].Strings[index2];
    List[i1].Strings[index1]:=Chaine2;
    List[i1].Strings[index2]:=Chaine1;
  end;
end;

function TFull.GetCount:Integer;
begin
  Result:=List[0].Count;
end;

procedure TFull.SetColumn(index1:Integer);
var
  i1:Integer;
begin
  if index1<=FColumn then Exit;
  for i1:=Items+1 to index1 do begin
    List[i1]:=TStringList.Create;
  end;
 FColumn:= index1;
 Items:= index1;
 CmVerifie;
end;

procedure TFull.CmVerifie;
var
  Max,i1,i2,Nombre:Integer;
begin
  Max:=-1;
  for i1:=0 to Items do begin
    if List[i1].Count>Max then Max:=List[i1].Count;
  end;
  for i1:=0 to Items do begin
    if List[i1].Count<Max then begin
      Nombre:=Max - List[i1].Count;
      for i2:=1 to Nombre do List[i1].Add('');
    end;
  end;
end;

function TFull.GetMaxString(index1:Integer):Integer;
var
  Position,Max,i1:Integer;
begin
  if index1>Items then begin
    Result:=-1;
    Exit;
  end;
  Position:=0;
  Max:=0;
  for i1:=0 to List[index1].Count-1 do begin
    if Length(List[index1].Strings[i1])>Max then begin
      Max:=Length(List[index1].Strings[i1]);
      Position:=i1;
    end;
  end;
  Result:=Position;
end;

procedure TFull.CmFillEmpty(index1:Integer);
var
  i1:Integer;
begin
  for i1:=0 to List[index1].Count-1 do begin
    if List[index1].Strings[i1]='' then begin
      List[index1].Strings[i1]:=StringOfChar('',20);
    end;
  end;
end;

procedure TFull.CmKillEmpty(index1:Integer);
var
  i1:Integer;
begin
  for i1:=0 to List[index1].Count-1 do begin
    if List[index1].Strings[i1]=StringOfChar('',20) then begin
      List[index1].Strings[i1]:= '';
    end;
  end;
end;

function TFull.GetSubCount(index1:Integer):Integer;
var
  i1:Integer;
begin
  for i1:=0 to List[index1].Count-1 do begin
    if List[index1].Strings[i1]='' then begin
      Result:=i1-1;
      Exit;
    end;
  end;
  Result:=List[index1].Count;
end;

procedure TFull.Update;
begin
  CmVerifie;
end;

function TFull.ShowAllLine(Index:Integer):String;
var
  i1:Integer;
begin
  Result:='';
  for i1:=0 to Items do begin
    Result:=Result+'['+List[i1].Strings[Index]+']';
  end;
end;

procedure TFull.SetItems(FCount:Integer);
var
  i1:Integer;
begin
  for i1:=0 to Items do begin
    List[i1].Free;
  end;
  Items:=FCount;
  for i1:=0 to Items do begin
    List[i1]:=TStringList.Create;
  end;
end;

procedure TFull.ReadFiles(ParentFile:String);
begin
  ReadFiles(ParentFile,True);
end;


procedure TFull.ReadFiles(ParentFile:String;Include:Boolean);
begin
  Clear;
  MySource.ReadFiles(ParentFile,List[0],Include);
  UpDate;
end;

procedure TFull.ReadDirectory(ParentDirectory:String);
begin
  Clear;
  MySource.ReadDirectory(ParentDirectory,List[0]);
  UpDate;
end;

procedure TFull.ReadOnlyDirectory(ParentDirectory:String);
begin
  Clear;
  MySource.ReadOnlyDirectory(ParentDirectory,List[0]);
  UpDate;
end;

procedure TFull.ReadOnlyFiles(ParentFile:String);
begin
  ReadOnlyFiles(ParentFile,True);
end;

procedure TFull.ReadOnlyFiles(ParentFile:String;Include:Boolean);
begin
  Clear;
  MySource.ReadOnlyFiles(ParentFile,List[0],Include);
  UpDate;
end;


procedure Register;
begin
  RegisterComponents('MyControl1', [TFull]);
end;

end.
