unit Hour;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  THour = class(TTimer)
  private
    { Private declarations }
  protected
    { Protected declarations }
    function GetTime:String;
    procedure SetTimer(Time:Integer);
    function GetTimer:Integer;
    function GetHour:String;
    function GetFullDate:String;
    function GetDate:String;
    function GetLapse:Integer;
    function GetFirst:Boolean;
    procedure SetFirst(FBolean:Boolean);
  public
    { Public declarations }
    FBegin,FEnd,FInternet1,FInternet2:Integer;
    OnF,PauseF,FFirst,OldTape:Boolean;
    Trace,MaxTimer:Integer;
  public
    constructor Create(AOwner:TComponent);override;
    procedure SetOn;
    procedure SetOff;
    procedure Pause;
    procedure Reset;
    property Time:String read GetTime;
    property FTimer:Integer read GetTimer write SetTimer;
    property Hour:String read GetHour;
    property Date:String read GetDate;
    property FullDate:String read GetFullDate;
    property Elapse:Integer read GetLapse;
    property First:Boolean read GetFirst write SetFirst;
  published
    { Published declarations }
  end;

procedure Register;

implementation

constructor THour.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  Trace:=0;
  Interval:=100;
  FFirst:=True;
end;

procedure THour.SetOn;
begin
  OnF:=True;
  FBegin:=GetTickCount;
  FEnd:=0;
  PauseF:=False;
end;

procedure THour.SetOff;
begin
  OnF:=False;
  FEnd:=GetTickCount;
  PauseF:=False;
end;

function THour.GetTime:String;
var
  f,s,st,Heure,Restant,Minute,Seconde:Integer;
begin
  if OnF then FEnd:=GetTickCount;
  f:=FEnd;
  s:=FBegin;
  st:=(f - s) div 1000;
  Heure:=st div 3600;
  Restant:=st-(Heure*3600);
  Minute:=Restant div 60;
  Restant:=Restant-(Minute*60);
  Seconde:=Restant;
  Result:=Format('%.2dh%.2d.%.2d',[Heure,Minute,Seconde]);
end;

procedure THour.SetTimer(time:Integer);
begin
  FBegin:=FBegin+time;
end;

function THour.GetTimer:Integer;
begin
  Result:=(Integer(GetTickCount)-FBegin) div 1000;
end;

procedure THour.Reset;
begin
  SetOff;
  SetOn;
end;

function THour.GetHour:String;
begin
  Result:=FormatDateTime('hh:mm:ss', Now);
end;

function THour.GetFullDate:String;
begin
  Result:=FormatDateTime('dddd , le d mmmm yyyy',Now);
end;

function THour.GetDate:String;
var
  AYear,AMonth,ADay:Word;
begin
  DecodeDate(Now,AYear, AMonth, ADay);
  Result:=Format('%.2d.%.2d.%.4d',[ADay,AMonth,AYear]);
end;

procedure THour.Pause;
var
  Lapse:Integer;
begin
  if not PauseF then
  begin
    OldTape:=OnF;
    OnF:=False;
    PauseF:=True;
    FInternet1:=GetTickCount;
    Exit;
  end;
  if PauseF then
  begin
    Lapse:=Integer(GetTickCount)-FInternet1;
    FBegin:=FBegin+Lapse;
    PauseF:=False;
    OnF:=OldTape;
  end;
end;

function THour.GetLapse:Integer;
begin
  Result:=-1;
  if not OnF then Exit;
  Result:=(Integer(GetTickCount)-FBegin) div 1000;
end;

function THour.GetFirst:Boolean;
begin
  Result:=True;
  if FFirst then
  begin
    FFirst:=False;
    Exit;
  end;
  Result:=False;
end;

procedure THour.SetFirst(FBolean:Boolean);
begin
  FFirst:=FBolean;
end;

procedure Register;
begin
  RegisterComponents('MyControl2', [THour]);
end;

end.
