unit IfoInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  vstrip;

type
  TIfoInfo = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FFileName:String;
    FFileLength:String;
    FTimeLength:Integer;
  public
    { Public declarations }
    AudioList:TStringList;
  public
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    function Execute:Boolean;
  published
    { Published declarations }
    property FileName:String Read FFileName Write FFileName;
    property FileLength:String read FFileLength write FFileLength;
    property TimeLength:Integer read FTimeLength write FTimeLength;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Divx4', [TIfoInfo]);
end;

constructor TIfoInfo.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  AudioList:=TStringList.Create;
  AudioList.Clear;
end;

destructor TIfoInfo.Destroy;
begin
  try
    AudioList.Free;
  except
  end;
end;

function TIfoInfo.Execute:Boolean;
var
  ifo_flags,ifo_handle:Cardinal;
  ANumCells:Integer;
  ALength:t_vs_time;
  j,i1:Integer;
begin
  Result:=False;
  AudioList.Clear;
  if not FileExists(FFileName) then Exit;
  ifo_flags:=fio_USE_ASPI;
  ifo_handle:=ifoOpen(PChar(FFileName),ifo_flags);
  if ifo_handle<>0 then begin
    ANumCells:=ifoGetPGCIInfo(ifo_handle,0,ALength);
    FFileLength:=Format('%.2u:%.2u:%.2u:%.2u in %d cell(s)',[ALength[0],ALength[1],ALength[2],ALength[3],ANumCells]);
    FTimeLength:=ALength[0]*3600+ALength[1]*60+ALength[2];
    j:=ifoGetNumAudio(ifo_handle);
    for i1:=0 to j-1 do begin
      AudioList.Add(Format('%d. %s',[i1,ifoGetAudioDesc(ifo_handle,i1)]));
    end;
    Result:=True;
  end
  else Exit;
end;

end.
