unit MySource;

interface

uses Dialogs,Classes,FileCtrl,Windows,SysUtils,Forms,ShellApi,extctrls,
     stdctrls,Graphics,Controls,Buttons;

type
  // Different OS platforms
  TWinType = (wtWindows95, wtWindowsNT, wtWin32s, wtUnknown);
     
{ this is the declaration of MyString...}

function MyUpper(line:String):String;
function DToS(chaine:Double;virgule:Integer):String;overload;
function DToS(chaine:Double):String;overload;
function ReturnLine(chaine:String):String;
function PlacePoint(chaine:String):String;overload;
function PlacePoint(chaine:Integer):String;overload;
function CopyToEnd(chaine:String;pos:Integer):String;
function Replace(chaine:String;pos:Integer;FNew:String):String;
function UmLine(FVirgule:Integer;FString:String):String;
function UmLineCount(FString:String):Integer;
function Copy(chaine:String;Position,Size:Integer):String;
function MyFormat(chaine:String;FT1:array of Const):String;overload;

{this is the declaration of MyFile...}

function RemoveSlash(chaine:String):String;
function SlashSep(chaine,s:String):String;
function ReadDirectory(ParentDirectory:String;DirectoryList:TStringList):Integer;
procedure ReadDirectoryNames(ParentDirectory:String;DirectoryList:TStringList);
function ReadOnlyDirectory(ParentDirectory:String;DirectoryList:TStringList):Integer;
function ReadFiles(ParentFile:String;FileList:TStringList;Include:Boolean):Integer;overload;
function ReadFiles(ParentFile:String;FileList:TStringList):Integer;overload;
procedure ReadFilesNames(ParentFile:String;FileList:TStringList;Include:Boolean);
function ReadOnlyFiles(ParentFile:String;FileList:TStringList;Include:Boolean):Integer;overload;
function ReadOnlyFiles(ParentFile:String;FileList:TStringList):Integer;overload;
function FileSizer(ParentFile:String):Integer;
function DoCompareFile(File1,File2:String):Boolean;overload;
function DoCompareFile(File1,File2:String;Panel:TPanel):Boolean;overload;
function IsDirectoryEmpty(directory:String):Boolean;
function PathCopyFile(file1,file2:String):Boolean;
function RemoveFile(file1:String):Boolean;
function DeleteDirectory(directory:String):Boolean;
procedure DeleteDirectory2(ParentDirectory:String;List1:TStringList);
function BeforeDirectory(Directory:String):String;
function TempDirectory():String;
function WindowsDirectory():String;
function WindowsSystemDirectory():String;
procedure SortFile(list:TStringList);
function SHGetFileIndex(file1:String):Integer;
function SHGetFileName(file1:String):String;
function GetAttribute(file1:String):String;
function HasAttr(FileName:String;Attr:Integer):Boolean;
function SHGetFileIcon(file1:String):HICON;
procedure MoveFileInFile(FileFrom,FileTo:String);
procedure MoveFileFrom(FileFrom:String;Position:Integer;FileTo:String);
procedure MoveFileFromTo(FileFrom:String;Position:Integer;FileTo:String;FSize:Integer);
function ParentDirectory(FString:String):String;
function CalculSize(FFile:String;MaxSize:Integer):TPoint;overload;
function CalculSize(FFile:String):TPoint;overload;
function DoFindInFile(FString,FSearch:PChar;FSize1,FSize2,FPos:Integer):Integer;
function ExecuteFile(const FileName, Params, DefaultDir: string;ShowCmd: Integer): THandle;


{ this is the declaration of System...}

procedure ShowHandle;
function GetAllHandle:Integer;
function AnsiStringToDateTime(date,hour:String):TDateTime;
function DateToAnsiString(date:TDateTime):String;
function TimeToAnsiString(time:TDateTime):String;
function AdvInputQuery(const ACaption, APrompt: string;  var Value: string): Boolean;
function GetAveCharSize(Canvas: TCanvas): TPoint;
function TransformeTime(FInteger:Integer):String;
function Exposant(Fx,Fy:Integer):Double;
procedure ShowMessage(FInteger:Integer);overload;
procedure ShowMessage(FString:String);overload;
procedure Wait(FInteger:Integer);
procedure DoCloseWindow;
function GetWinType: TWinType;
function MyShellExecute(FProgram,FCommand:String):Boolean;
function MyShellExecuteBeta(FProgram,FCommand:String):Boolean;


implementation

{ implementation of MyString}

function CopyToEnd(chaine:String;pos:Integer):String;
var
  Nombre:Integer;
begin
  Nombre:=Length(chaine)-pos+1;
  Result:=Copy(chaine,pos,Nombre);
end;

function MyUpper(line:String):String;
var
  s1:String;
  i1:Integer;
begin
  s1:=AnsiUpperCase(line);
  for i1:=1 to Length(s1) do begin
    case s1[i1] of
      '','','','','','','','':s1[i1]:='E';
      '','','','','','','':s1[i1]:='A';
      '','','','','','':s1[i1]:='U';
      '','':s1[i1]:='C';
      '','','','','','':s1[i1]:='I';
      '','','','','','':s1[i1]:='O';
      '':s1[i1]:='Y';
      '','':s1[i1]:='N';
    end;
  end;
  Result:=s1;
end;

function DToS(chaine:Double):String;
begin
  Result:=DToS(chaine,-1);
end;

function DToS(chaine:Double;virgule:Integer):String;
begin
  Result:='';
  if virgule<-1 then virgule:=-1;
  if virgule>10 then virgule:=10;
  case virgule of
    -1:Result:=Format('%f',[chaine]);
    10:Result:=Format('%10f',[chaine]);
    0:Result:=Format('%.0f',[chaine]);
    1:Result:=Format('%.1f',[chaine]);
    2:Result:=Format('%.2f',[chaine]);
    3:Result:=Format('%.3f',[chaine]);
    4:Result:=Format('%.4f',[chaine]);
    5:Result:=Format('%.5f',[chaine]);
    6:Result:=Format('%.6f',[chaine]);
    7:Result:=Format('%.7f',[chaine]);
    8:Result:=Format('%.8f',[chaine]);
    9:Result:=Format('%.9f',[chaine]);
  end;
end;

function ReturnLine(chaine:String):String;
var
  i1:Integer;
begin
  Result:='';
  for i1:=Length(chaine) downto 1 do begin
    Result:=Result + Copy(chaine,i1,1);
  end;
end;

function PlacePoint(chaine:Integer):String;
begin
  Result:=PlacePoint(IntToStr(chaine));
end;

function PlacePoint(chaine:String):String;
var
  Minus:Boolean;
  Chaine4,Chaine3,Chaine2,Chaine1:String;
  i1,i2,Reste:Integer;
begin
  if chaine='' then begin
    Result:='';
    Exit;
  end;
  Minus:=False;
  Chaine3:=chaine;
  if StrToIntDef(Chaine3,0)<0 then begin
    Chaine3:=IntToStr(StrToIntDef(chaine,0)*-1);
    Minus:=True;
  end;
  Chaine1:=ReturnLine(Chaine3);
  Chaine2:='';
  for i1:=1 to Length(Chaine1) do begin
    Chaine2:=Chaine2 + Copy(Chaine1,i1,1);
    i2:=i1 div 3;
    Reste:=i1 - (i2*3);
    if Reste=0 then Chaine2:=Chaine2+'.';
  end;
  Chaine4:=ReturnLine(Chaine2);
  if Chaine4[1]='.' then Chaine4:=CopyToEnd(Chaine4,2);
  if Minus then Chaine4:='-'+Chaine4;
  Result:=Chaine4;
end;

function Replace(chaine:String;pos:Integer;FNew:String):String;
var
  FCopy1,FCopy2:String;
begin
  if pos=0 then FCopy1:=''
  else FCopy1:=Copy(chaine,1,pos-1);
  FCopy2:=CopyToEnd(chaine,pos+1);
  Result:=FCopy1+FNew+FCopy2;
end;

function UmLine(FVirgule:Integer;FString:String):String;
var
  FPos:array[0..101] of Integer;
  FPointer:Integer;
  i1:Integer;
  FCurrent1:String;
begin
  FPointer:=2;
  for i1:=1 to 100 do FPos[i1]:=0;
  FPos[1]:=1;
  for i1:=1 to Length(FString) do begin
    if FString[i1]='*' then begin
      FPos[FPointer]:=i1;
      FPointer:=FPointer+1;
    end;
  end;
  if FVirgule+1=FPointer then begin
    Result:=CopyToEnd(FString,FPos[FVirgule]+1);
    Exit;
  end;
  FCurrent1:=Copy(FString,1,FPos[FVirgule+1]-1);
  if FVirgule<>1 then Result:=CopyToEnd(FCurrent1,FPos[FVirgule]+1)
  else Result:=Copy(FCurrent1,1,FPos[2]-1);
end;

function UmLineCount(FString:String):Integer;
var
  i1:Integer;
begin
  Result:=0;
  for i1:=1 to Length(FString) do begin
    if (FString[i1]='*') and (i1<Length(FString)) then Inc(Result);
  end;
end;


function Copy(chaine:String;Position,Size:Integer):String;
begin
  Result:=System.Copy(chaine,Position,Size);
end;

function MyFormat(chaine:String;FT1:array of const):String;
begin
  Result:=SysUtils.Format(chaine,FT1);
end;



{this is the declaration of MyFile...}

function RemoveSlash(chaine:String):String;
begin
  Result:='';
  if (Copy(chaine,1,1)='\') and (Copy(chaine,2,1)<>'\') then
    Result:=CopyToEnd(chaine,2)
  else
    Result:=chaine;
  if Copy(Result,Length(Result),1)='\' then
    Result:=Copy(Result,1,Length(Result)-1);
end;

function SlashSep(chaine,s:String):String;
begin
  Result:=RemoveSlash(chaine)+'\'+RemoveSlash(s);
end;

function ReadDirectory(ParentDirectory:String;DirectoryList:TStringList):Integer;
begin
  DirectoryList.Add(MyUpper(ParentDirectory));
  ReadDirectoryNames(ParentDirectory,DirectoryList);
  Result:=DirectoryList.Count;
end;

procedure ReadDirectoryNames(ParentDirectory:String;DirectoryList:TStringList);
var
  Status:Integer;
  SearchRec:TSearchRec;
begin
  Status:=FindFirst(SlashSep(ParentDirectory,'*.*'),30,SearchRec);
  try
    while Status=0 do begin
      if (SearchRec.Attr and faDirectory<>0) then begin
        if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then begin
          DirectoryList.Add(SlashSep(ParentDirectory,SearchRec.Name));
          ReadDirectoryNames(SlashSep(ParentDirectory,SearchRec.Name),DirectoryList);
        end;
      end;
      Status:=FindNext(SearchRec);
    end;
    FindClose(SearchRec);
  except
    FindClose(SearchRec);
  end;
end;

function ReadOnlyDirectory(ParentDirectory:String;DirectoryList:TStringList):Integer;
var
  Status:Integer;
  SearchRec:TSearchRec;
begin
  Status:=FindFirst(SlashSep(ParentDirectory,'*.*'),30,SearchRec);
  try
    while Status=0 do begin
      if (SearchRec.Attr and faDirectory<>0) then begin
        if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then begin
          DirectoryList.Add(SearchRec.Name);
        end;
      end;
      Status:=FindNext(SearchRec);
    end;
    FindClose(SearchRec);
  except
    FindClose(SearchRec);
  end;
  Result:=DirectoryList.Count;
end;

function ReadFiles(ParentFile:String;FileList:TStringList):Integer;
begin
  Result:=ReadFiles(ParentFile,FileList,True);
end;

function ReadFiles(ParentFile:String;FileList:TStringList;Include:Boolean):Integer;
begin
  ReadFilesNames(ParentFile,FileList,Include);
  Result:=FileList.Count;
end;

procedure ReadFilesNames(ParentFile:String;FileList:TStringList;Include:Boolean);
var
  Status:Integer;
  SearchRec:TSearchRec;
begin
  Status:=FindFirst(SlashSep(ParentFile,'*.*'),30,SearchRec);
  try
    while Status=0 do begin
      if (SearchRec.Attr and faDirectory<>0) then begin
        if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') and (SearchRec.Name<>'') then begin
          ReadFilesNames(Format('%s%s\',[SlashSep(ParentFile,''),SearchRec.Name]),FileList,Include);
        end;
      end
      else begin
        if (SearchRec.Attr and faVolumeID=0) then begin
          if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') and (SearchRec.Name<>'') then begin
            if Include then
              FileList.Add(Format('%s%s',[SlashSep(ParentFile,''),SearchRec.Name]))
            else
              FileList.Add(SearchRec.Name);
          end;
        end;
      end;
      Status:=FindNext(SearchRec);
    end;
    FindClose(SearchRec);
  except
    FindClose(SearchRec);
  end;
end;

function ReadOnlyFiles(ParentFile:String;FileList:TStringList):Integer;
begin
  Result:=ReadOnlyFiles(ParentFile,FileList,False);
end;

function ReadOnlyFiles(ParentFile:String;FileList:TStringList;Include:Boolean):Integer;
var
  Status:Integer;
  SearchRec:TSearchRec;
begin
  Status:=FindFirst(SlashSep(ParentFile,'*.*'),30,SearchRec);
  try
    while Status=0 do begin
      if (SearchRec.Attr and faDirectory<>0) then
      else begin
        if (SearchRec.Attr and faVolumeID=0) then begin
          if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then begin
            if Include then
              FileList.Add(SlashSep(ParentFile,SearchRec.Name))
            else
              FileList.Add(SearchRec.Name);
          end;
        end;
      end;
      Status:=FindNext(SearchRec);
    end;
    FindClose(SearchRec);
  except
    FindClose(SearchRec);
  end;
  Result:=FileList.Count;
end;

function FileSizer(ParentFile:String):Integer;
var
  FileHandle1:Integer;
begin
  FileHandle1:=FileOpen(ParentFile,fmOpenRead);
  Result:=FileSeek(FileHandle1,0,2);
  FileClose(FileHandle1);
end;

function DoCompareFile(File1,File2:String):Boolean;
var
  Buffer1,Buffer2:array[0..1000] of Char;
  FileHandle1,FileHandle2,Readed:Integer;
begin
  if File1=File2 then begin
    Result:=True;
    Exit;
  end;
  if (not FileExists(File1)) or (not FileExists(File2)) then begin
    Result:=False;
    Exit;
  end;
  if FileSizer(File1)<>FileSizer(File2) then begin
    Result:=False;
    Exit;
  end;
  FileHandle1:=FileOpen(File1,fmOpenRead);
  FileHandle2:=FileOpen(File2,fmOpenRead);

  Readed:=1;
  while Readed>0 do begin
    Readed:=FileRead(FileHandle1,Buffer1,1000);
    if (FileRead(FileHandle2,Buffer2,Readed)<>Readed) or
       (not CompareMem(@Buffer1,@Buffer2,Readed)) then begin
      FileClose(FileHandle1);
      FileClose(FileHandle2);
      Result:=False;
      Exit;
    end;
  end;
  FileClose(FileHandle1);
  FileClose(FileHandle2);
  Result:=True;
end;

function DoCompareFile(File1,File2:String;Panel:TPanel):Boolean;
var
  Buffer1,Buffer2:array[0..10000] of Char;
  FileHandle1,FileHandle2,Readed:Integer;
  Pos:Integer;
begin
  Pos:=0;
  Panel.Caption:='0';
  Panel.Update;
  if File1=File2 then begin
    Result:=True;
    Exit;
  end;
  if (not FileExists(File1)) or (not FileExists(File2)) then begin
    Result:=False;
    Exit;
  end;
  if FileSizer(File1)<>FileSizer(File2) then begin
    Result:=False;
    Exit;
  end;
  FileHandle1:=FileOpen(File1,fmOpenRead);
  FileHandle2:=FileOpen(File2,fmOpenRead);

  Readed:=1;
  while Readed>0 do begin
    Readed:=FileRead(FileHandle1,Buffer1,8196);
    Pos:=Pos+Readed;
    Panel.Caption:=PlacePoint(IntToStr(Pos));
    Panel.Update;
    Application.ProcessMessages;
    if (FileRead(FileHandle2,Buffer2,Readed)<>Readed) or
       (not CompareMem(@Buffer1,@Buffer2,Readed)) then begin
      FileClose(FileHandle1);
      FileClose(FileHandle2);
      Result:=False;
      Panel.Caption:='';
      Panel.Update;
      Exit;
    end;
  end;
  FileClose(FileHandle1);
  FileClose(FileHandle2);
  Panel.Caption:='';
  Panel.Update;
  Result:=True;
end;

function IsDirectoryEmpty(directory:String):Boolean;
var
  Status:Integer;
  SearchRec:TSearchRec;
begin
  Status:=FindFirst(SlashSep(directory,'*.*'),30,SearchRec);
  try
    while Status=0 do begin
      if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then begin
        FindClose(SearchRec);
        Result:=False;
        Exit;
      end;
      Status:=FindNext(SearchRec);
    end;
  except
    FindClose(SearchRec);
  end;
  Result:=True;
end;

function PathCopyFile(file1,file2:String):Boolean;
begin
  ForceDirectories(ExtractFileDir(File1));
  ForceDirectories(ExtractFileDir(File2));
  if FileExists(File2) then FileSetAttr(File2,0);
  Result:=CopyFile(Pointer(File1),Pointer(File2),False);
end;

function RemoveFile(file1:String):Boolean;
begin
  if not FileExists(file1) then Result:=False
  else begin
      FileSetAttr(file1,0);
      Result:=DeleteFile(file1);
  end;
end;

procedure DeleteDirectory2(ParentDirectory:String;List1:TStringList);
var
  Status:Integer;
  SearchRec:TSearchRec;
begin
  Status:=FindFirst(SlashSep(ParentDirectory,'*.*'),30,SearchRec);
  try
    while Status=0 do begin
      if (SearchRec.Attr and faDirectory<>0) then begin
        if (SearchRec.Name<>'.') and (SearchRec.Name<>'..') then begin
          DeleteDirectory2(SlashSep(ParentDirectory,SearchRec.Name),List1);
        end;
      end;
      Status:=FindNext(SearchRec);
    end;
    FindClose(SearchRec);
    List1.Add(ParentDirectory);
  except
    FindClose(SearchRec);
  end;
end;

function DeleteDirectory(directory:String):Boolean;
var
  List1:TStringList;
  i1:Integer;
begin
  List1:=TStringList.Create;
  List1.Clear;
  ReadFiles(directory,List1,True);
  for i1:=0 to List1.Count-1 do begin
    Application.ProcessMessages;
    RemoveFile(List1.Strings[i1]);
  end;

  List1.Clear;
  DeleteDirectory2(directory,List1);

  for i1:=0 to List1.Count-1 do begin
    RemoveDir(List1.Strings[i1]);
  end;

  try
    List1.Free;
  except
    List1.Free;
  end;
  RemoveDir(directory);
  Result:=not DirectoryExists(directory);
end;

function BeforeDirectory(Directory:String):String;
var
  Current1,Current2:String;
  Nombre1,Y1,i1:Integer;
begin
  Current1:=RemoveSlash(Directory);
  Current2:=ReturnLine(Current1);
  Nombre1:=AnsiPos('\',Current2);
  Y1:=0;
  for i1:=1 to Length(Current1) do begin
    if Copy(Current1,i1,1)='\' then Y1:=Y1+1;
  end;
  if Y1=0 then begin
    Result:='';
    Exit;
  end;
  Result:=RemoveSlash(Copy(Current1,1,Length(Current1)-Nombre1));
end;

function TempDirectory():String;
var
  Tempof:Array[0..1010] of char;
begin
  GetTempPath(1000,Tempof);
  Result:=Tempof;
end;

function WindowsDirectory():String;
var
  Tempof:Array[0..1010] of char;
begin
  GetWindowsDirectory(Tempof,1000);
  Result:=Tempof;
end;

function WindowsSystemDirectory():String;
var
  Tempof:Array[0..1010] of char;
begin
  GetSystemDirectory(Tempof,1000);
  Result:=Tempof;
end;

procedure SortFile(list:TStringList);
var
  List1,List2,List3:TStringList;
  i1,i2:Integer;
  Current1,Current2:String;
  CurrentX1,CurrentX2:String;
begin
  List1:=TStringList.Create;
  List2:=TStringList.Create;
  List3:=TStringList.Create;

  List1.Clear;
  List1.AddStrings(list);
  List2.Clear;
  List3.Clear;

  for i1:=0 to List1.Count-1 do begin
    Current1:=List1.Strings[i1];
    List1.Strings[i1]:= Format('%.10d%s',[Length(ExtractFileDir(Current1)),Current1]);
  end;
  List1.Sort;
  for i1:=0 to List1.Count-1 do begin
    Current1:=List1.Strings[i1];
    List1.Strings[i1]:=CopyToEnd(Current1,11);
  end;
  List3.Clear;
  for i1:=0 to List1.Count-1 do begin
    Current1:=List1.Strings[i1];
    Current2:=ExtractFileDir(Current1);
    if Current1<>'*' then begin
      List2.Clear;
      for i2:=i1 to List1.Count-1 do begin
        CurrentX1:=List1.Strings[i2];
        CurrentX2:=ExtractFileDir(CurrentX1);
        if CurrentX1<>'*' then begin
          if CurrentX2=Current2 then begin
            List2.Add(CurrentX1);
            List1.Strings[i2]:='*';
          end;
        end;
      end;
      List2.Sort;
      List3.AddStrings(List2);
    end;
  end;
  list.Clear;
  list.AddStrings(List3);
  try
    List1.Free;
  except
  end;
  try
    List2.Free;
  except
  end;
  try
    List3.Free;
  except
  end;
end;

function SHGetFileIndex(file1:String):Integer;
var
  fi:SHFILEINFO;
  Current1:String;
begin
  Current1:='*'+ExtractFileExt(file1);
  SHGetFileInfo(PChar(Current1),FILE_ATTRIBUTE_NORMAL,fi,sizeof(fi),
                SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_USEFILEATTRIBUTES or
                SHGFI_TYPENAME);
  Result:=fi.iIcon;
end;

function SHGetFileName(file1:String):String;
var
  fi:SHFILEINFO;
  Current1:String;
begin
  Current1:='*'+ExtractFileExt(file1);
  SHGetFileInfo(PChar(Current1),FILE_ATTRIBUTE_NORMAL,fi,sizeof(fi),
                 SHGFI_SYSICONINDEX or SHGFI_SMALLICON or SHGFI_USEFILEATTRIBUTES or
                 SHGFI_TYPENAME);
  Result:=fi.szTypeName;
end;

function SHGetFileIcon(file1:String):HICON;
var
  fi:SHFILEINFO;
begin
  SHGetFileInfo(PChar(file1),0,fi,sizeof(fi),SHGFI_SYSICONINDEX);
  Result:=fi.hIcon;
end;

function GetAttribute(file1:String):String;
var
  FSearchRec:TSearchRec;
begin
  FindFirst(file1,30,FSearchRec);
  Result:=Format('%.10d%.10d',[FSearchRec.Attr,FSearchRec.Time]);
  FindClose(FSearchRec);
end;

function HasAttr(FileName:String;Attr:Integer):Boolean;
var
  attribtest:Integer;
begin
  attribtest:=FileGetAttr(FileName);
  if (attribtest and Attr<>0) then begin
    Result:=True;
    Exit;
  end;
  Result:=False;
end;

procedure MoveFileInFile(FileFrom,FileTo:String);
var
  Buffer1:array[0..9000] of Char;
  FileHandle1,FileHandle2:Integer;
  MaxSize,Readed:Integer;
begin
  MaxSize:=8196;
  FileHandle1:=FileOpen(FileTo,fmOpenReadWrite);
  FileHandle2:=FileOpen(FileFrom,fmOpenRead);
  FileSeek(FileHandle1,0,2);
  repeat
    Buffer1:='';
    Readed:=FileRead(FileHandle2,Buffer1,MaxSize);
    FileWrite(FileHandle1,Buffer1,Readed);
  until Readed<MaxSize;
  FileClose(FileHandle2);
  FileClose(FileHandle1);
end;

procedure MoveFileFrom(FileFrom:String;Position:Integer;FileTo:String);
var
  Buffer1:array[0..9000] of Char;
  Readed,FileHandle1,FileHandle2,MaxSize:Integer;
begin
  MaxSize:=8196;
  FileHandle1:=FileOpen(FileFrom,fmOpenReadWrite);
  FileSeek(FileHandle1,Position,0);
  FileHandle2:=FileCreate(FileTo);
  repeat
    Buffer1:='';
    Readed:=FileRead(FileHandle1,Buffer1,8196);
    FileWrite(FileHandle2,Buffer1,Readed);
  until Readed<MaxSize;
  FileClose(FileHandle2);
  FileClose(FileHandle1);
end;

procedure MoveFileFromTo(FileFrom:String;Position:Integer;FileTo:String;FSize:Integer);
var
  Buffer1:array[0..9000] of Char;
  FileHandle1,FileHandle2,Nombre,Reste,i1:Integer;
begin
  FileHandle1:=FileOpen(FileFrom,fmOpenReadWrite);
  FileSeek(FileHandle1,Position,0);
  FileHandle2:=FileCreate(FileTo);
  Nombre:=FSize div 1000;
  Reste:=FSize-Nombre*1000;
  for i1:=1 to Nombre do begin
    Buffer1:='';
    FileRead(FileHandle1,Buffer1,1000);
    FileWrite(FileHandle2,Buffer1,1000);
  end;
  if Reste>0 then begin
    Buffer1:='';
    FileRead(FileHandle1,Buffer1,Reste);
    FileWrite(FileHandle2,Buffer1,Reste);
  end;
  FileClose(FileHandle2);
  FileClose(FileHandle1);
end;

function ParentDirectory(FString:String):String;
var
  i1:Integer;
  Pos:array[0..1001] of Integer;
  FCount:Integer;
begin
  FCount:=0;
  for i1:=1 to Length(FString) do begin
    if FString[i1]='\' then begin
      FCount:=FCount+1;
      Pos[FCount]:=i1;
    end;
  end;
  if FCount<=1 then begin
    Result:=FString;
    Exit;
  end;
  Result:=Copy(FString,1,Pos[FCount-1]-1);
end;

function CalculSize(FFile:String):TPoint;
begin
  CalculSize(FFile,8196);
end;

function CalculSize(FFile:String;MaxSize:Integer):TPoint;
var
  FSize,FNombre,FRestant:Integer;
begin
  FSize:=FileSizer(FFile);
  FNombre:=FSize div MaxSize;
  FRestant:=FSize - FNombre*MaxSize;
  Result.x:=FNombre;
  Result.y:=FRestant;
end;

function DoFindInFile(FString,FSearch:PChar;FSize1,FSize2,FPos:Integer):Integer;
var
  i1,i2:Integer;
begin
  Dec(FSize1);
  Dec(FSize2);
  i1:=FPos;
  while i1<=FSize1 do begin
    if (FString[i1]=FSearch[0]) then begin
      i2:=0;
      while i2<=FSize2 do begin
        if FString[i1]=FSearch[i2] then begin
           Inc(i1);
           Inc(i2);
        end
        else begin
          i1:=i1-i2+1;
          i2:=-1;
          Break;
        end;
      end;
      if i2<>-1 then begin
        Result:=i1-i2;
        Exit;
      end;
    end;
    Inc(i1);
  end;
  Result:=-1;
end;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;



{ this is the declaration of System...}

procedure ShowHandle;
var
  FileHandle1:Integer;
begin
  FileHandle1:=FileCreate(SlashSep(TempDirectory,'Test.r'));
  FileClose(FileHandle1);
  DeleteFile(SlashSep(TempDirectory,'Test.r'));
  ShowMessage(IntToStr(FileHandle1));
end;

function GetAllHandle:Integer;
var
  FileHandle1:Integer;
begin
  FileHandle1:=FileCreate(SlashSep(TempDirectory,'Test.r'));
  FileClose(FileHandle1);
  Result:=FileHandle1;
  DeleteFile(SlashSep(TempDirectory,'Test.r'));
end;

function AnsiStringToDateTime(date,hour:String):TDateTime;
var
  Date1,Date2:TDateTime;
  Day,Month,Year:String;
  iHour,iMinute,iSeconde:String;
begin
  Date1:=Now;
  Date2:=Now;
  Result:=Now;
  if (date='') and (hour='') then Exit;
  if date<>'' then begin
    Year:=Copy(date,7,4);
    Month:=Copy(date,4,2);
    Day:=Copy(date,1,2);
    Date1:=EncodeDate(StrToInt(Year),StrToInt(Month),StrToInt(Day));
  end;
  if hour<>'' then begin
    iHour:=Copy(hour,1,2);
    iMinute:=Copy(hour,4,2);
    iSeconde:=Copy(hour,7,2);
    Date2:=EncodeTime(StrToInt(iHour),StrToInt(iMinute),StrToInt(iSeconde),0);
  end;
  ReplaceDate(Result,Date1);
  ReplaceTime(Result,Date2);
end;

function DateToAnsiString(date:TDateTime):String;
var
  wYear,wMonth,wDay:Word;
begin
  DecodeDate(date,wYear,wMonth,wDay);
  Result:=Format('%.02d-%.02d-%.04d',[wDay,wMonth,wYear]);
end;

function TimeToAnsiString(time:TDateTime):String;
var
  iHour,iMinute,iSeconde,iMSec:Word;
begin
  DecodeTime(time,iHour,iMinute,iSeconde,iMSec);
  Result:=Format('%.02d:%.02d.%.02d',[iHour,iMinute,iSeconde]);
end;

function AdvInputQuery(const ACaption, APrompt: string;  var Value: string): Boolean;
var
  Form: TForm;
  Prompt: TLabel;
  Edit: TEdit;
  DialogUnits: TPoint;
  ButtonTop, ButtonWidth, ButtonHeight: Integer;
begin
  Result := False;
  Form := TForm.Create(Application);
  with Form do
    try
      BorderIcons:=[biSystemMenu,biMinimize];
      Icon:=Application.Icon;
      Canvas.Font := Font;
      DialogUnits := GetAveCharSize(Canvas);
      BorderStyle := bsSingle;
      Caption := ACaption;
      ClientWidth := MulDiv(180, DialogUnits.X, 4);
      ClientHeight := MulDiv(63, DialogUnits.Y, 8);
      Position := poScreenCenter;
      Prompt := TLabel.Create(Form);
      with Prompt do begin
        Parent := Form;
        AutoSize := True;
        Left := MulDiv(8, DialogUnits.X, 4);
        Top := MulDiv(8, DialogUnits.Y, 8);
        Caption := APrompt;
      end;
      Edit := TEdit.Create(Form);
      with Edit do begin
        Parent := Form;
        Left := Prompt.Left;
        Top := MulDiv(19, DialogUnits.Y, 8);
        Width := MulDiv(164, DialogUnits.X, 4);
        MaxLength := 255;
        Text := Value;
        SelectAll;
      end;
      ButtonTop := MulDiv(41, DialogUnits.Y, 8);
      ButtonWidth := MulDiv(50, DialogUnits.X, 4);
      ButtonHeight := MulDiv(16, DialogUnits.Y, 8);
      with TBitBtn.Create(Form) do begin
        Parent := Form;
        Caption := 'Ok';
        Kind:=bkOK;
        ModalResult := mrOk;
        Cursor:=crHandPoint;
        Default := True;
        SetBounds(MulDiv(38, DialogUnits.X, 4), ButtonTop, ButtonWidth,
          ButtonHeight);
      end;
      with TBitBtn.Create(Form) do begin
        Parent := Form;
        Caption := 'Arrter';
        Kind:=bkCancel;
        ModalResult := mrCancel;
        Cursor:=crHandPoint;
        Cancel := True;
        SetBounds(MulDiv(92, DialogUnits.X, 4), ButtonTop, ButtonWidth,
          ButtonHeight);
      end;
      if ShowModal = mrOk then begin
        Value := Edit.Text;
        Result := True;
      end;
    finally
      Form.Free;
  end;
end;

function GetAveCharSize(Canvas: TCanvas): TPoint;
var
  I: Integer;
  Buffer: array[0..51] of Char;
begin
  for I := 0 to 25 do Buffer[I] := Chr(I + Ord('A'));
  for I := 0 to 25 do Buffer[I + 26] := Chr(I + Ord('a'));
  GetTextExtentPoint(Canvas.Handle, Buffer, 52, TSize(Result));
  Result.X := Result.X div 52;
end;

function TransformeTime(FInteger:Integer):String;
var
  FRestant,FMinute,FSeconde,FHour:Integer;
begin
  FHour:=FInteger div 3600;
  FRestant:=FInteger-(FHour*3600);
  FMinute:=FRestant div 60;
  FSeconde:=FRestant-(FMinute*60);
  Result:=Format('%.02d.%.02d.%.02d',[FHour,FMinute,FSeconde]);
end;

function Exposant(Fx,Fy:Integer):Double;
var
  i1:Integer;
begin
  Result:=1;
  if Fy=0 then Exit;
  for i1:=1 to Fy do begin
    Result:=Result*Fx;
  end;
end;

procedure ShowMessage(FInteger:Integer);
begin
  Dialogs.ShowMessage(IntToStr(FInteger));
end;

procedure ShowMessage(FString:String);
begin
  Dialogs.ShowMessage(FString);
end;


procedure Wait(FInteger:Integer);
var
  ABegin:Integer;
begin
  ABegin:=GetTickCount;
  while Integer(GetTickCount)-ABegin<FInteger do begin
  end;
end;

function GetWinType: TWinType;
var
  VersionInfo: TOSVersionInfo;
begin
  Result := wtUnknown;
  VersionInfo.dwOSVersionInfoSize := SizeOf(VersionInfo);
  GetVersionEx(VersionInfo);
  case VersionInfo.dwPlatformId of
    VER_PLATFORM_WIN32S : Result := wtWin32s;
    VER_PLATFORM_WIN32_WINDOWS : Result := wtWindows95;
    VER_PLATFORM_WIN32_NT : Result := wtWindowsNT;
  end;
end;


procedure DoCloseWindow;
var
  TokenHandle: THandle;
  NewState, PreviousState: TTokenPrivileges;
  ReturnLength: DWORD;
begin
  // Request the right to shutdown Windows NT/2000 (not needed for Windows
  //95/98/ME)
  if GetWinType = wtWindowsNT then begin
    if not OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or
                            TOKEN_QUERY, TokenHandle) then
      RaiseLastWin32Error;
    try
      NewState.PrivilegeCount := 1;
      if not LookupPrivilegeValue(nil, 'SeshutdownPrivilege',
                                  NewState.Privileges[0].LUID) then begin
        RaiseLastWin32Error;
      end;
      NewState.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
      ReturnLength := 0;
      if not AdjustTokenPrivileges(TokenHandle, False, NewState,
                                   SizeOf(NewState), PreviousState, ReturnLength) then begin
        RaiseLastWin32Error;
      end;
    finally
      CloseHandle(TokenHandle);
    {// shutdown Windows}
    if not ExitWindowsEx(EWX_FORCE or EWX_shutdown or EWX_POWEROFF, 0) then
      RaiseLastWin32Error;
    end;
  end
  else begin
    if not ExitWindowsEx(EWX_FORCE or EWX_shutdown or EWX_POWEROFF,0) then begin
      RaiseLastWin32Error;
    end;
  end;
end;

function MyShellExecute(FProgram,FCommand:String):Boolean;
{var
  exInfo:TShellExecuteInfo;
  exitCode:DWORD;}
begin
  Result:=MyShellExecuteBeta(FProgram,FCommand);
{  FillChar(exInfo,SizeOf(exInfo),0);
  with exInfo do begin
    cbSize:=SizeOf(exInfo);
    fMask:=SEE_MASK_NOCLOSEPROCESS or SEE_MASK_FLAG_DDEWAIT;
    Wnd:=Application.Handle;
    lpVerb:='OPEN';
    lpFile:=PChar(FProgram);
    nShow:=SW_SHOWNORMAL;
    lpParameters:=PChar(FCommand);
  end;
  if ShellExecuteEx(@exInfo) then begin
    while GetExitCodeProcess(exInfo.hProcess,exitcode)
          and (exitcode=STILL_ACTIVE)
    do begin
      Application.ProcessMessages;
    end;
    CloseHandle(exInfo.hProcess);
  end;
  Result:=True;}
end;

function MyShellExecuteBeta(FProgram,FCommand:String):Boolean;
var
  pi:PROCESS_INFORMATION;
  si:TStartupInfo;
begin
  ZeroMemory(@si,SizeOf(si));
  si.cb:=SizeOf(si);
  ZeroMemory(@pi,sizeof(pi));
  if CreateProcess(nil,PChar(FProgram+' '+FCommand),nil,nil,false,0,nil,nil,si,pi) then begin
    Application.ProcessMessages;
    WaitForSingleObject(pi.hProcess,INFINITE);
    CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);
    Result:=True;
    Exit;
  end;
  Result:=False;
end;




end.
