unit AviPlayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, Demande, LedControl, MPlayer, ComCtrls, StdCtrls,vfw,
  OleServer, dspack,DirectShow;

type
  TMediaState=(fPause,fPlay,fStop,fRewind,fForwind,fLoad,fScreen,fEnd,fBegin,fResume);
  TMyUAviPlayer = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    SpeedRewind: TSpeedButton;
    SpeedPlay: TSpeedButton;
    SpeedPause: TSpeedButton;
    SpeedStop: TSpeedButton;
    SpeedForward: TSpeedButton;
    SpeedLoad: TSpeedButton;
    Demande1: TDemande;
    LedControl1: TLedControl;
    LedControl2: TLedControl;
    LedControl3: TLedControl;
    Timer1: TTimer;
    SpeedScreen: TSpeedButton;
    FilterGraph1: TDSFilterGraph2;
    DSTrackBar1: TDSTrackBar;
    Panel3: TPanel;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedLoadClick(Sender: TObject);
    procedure SpeedPlayClick(Sender: TObject);
    procedure SpeedScreenClick(Sender: TObject);
    procedure SpeedPauseClick(Sender: TObject);
    procedure SpeedStopClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FilterGraph1GraphComplete(sender: TComponent;
      Result: HRESULT; Renderer: IBaseFilter);
  private
    { Private declarations }
    FFileName:String;
    IsFullScreen:Boolean;
    FState:TFilter_State;
    FLangue:Integer;
    FEnter:Boolean;
  private
    procedure SetLangue(FLan:Integer);
  public
    { Public declarations }
    constructor Create(AOwner:TComponent);override;
    destructor Destroy;override;
    procedure Feed;
    procedure MyMouseDown(FX,FY:Integer);
    procedure TryStop;
    function CheckValidity(FButton:TMediaState):Boolean;
    procedure CheckButton(FButton:TMediaState);
    procedure MyDoShow;
    procedure MyDoHide;
    procedure ShowPlayTime(FTime:Integer);
  published
    property FileName:String read FFileName write FFileName;
    property Langue:Integer read FLangue write SetLangue;
  end;

var
  MyUAviPlayer: TMyUAviPlayer;

implementation

uses AviPlayer2;

{$R *.DFM}

constructor TMyUAviPlayer.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  IsFullScreen:=False;
  CheckButton(FBegin);
  ShowPlayTime(0);
  Langue:=0;
  FEnter:=True;
end;

destructor TMyUAviPlayer.Destroy;
begin
  inherited Destroy;
end;

procedure TMyUAviPlayer.Feed;
begin
  case FLangue of
    1:begin
      Caption:='Lecteur NeoDivx pour DIVX';
      SpeedPlay.Hint:='Pour Jouer l''AVI';
      SpeedStop.Hint:='Pour Stopper l''AVI';
      SpeedPause.Hint:='Pour Mettre en Pause';
      SpeedLoad.Hint:='Pour Appeller l''AVI';
      SpeedRewind.Hint:='Pour Aller vers l''arrire';
      SpeedForward.Hint:='Pour Aller vers l''avant';
      if not IsFullScreen then SpeedScreen.Hint:='Pour Agrandir l''ecran'
      else SpeedScreen.Hint:='Pour rduire l''image';
      Label1.Caption:='Si je suis cach, cliquez avec le '+#13+
                      'droit de la souris pour me revoir!';
    end;
    0:begin
      Caption:='NeoDivx DIVX Player';
      SpeedPlay.Hint:='To Play AVI';
      SpeedStop.Hint:='To Stop AVI';
      SpeedPause.Hint:='To Pause AVI';
      SpeedLoad.Hint:='To Load AVI';
      SpeedRewind.Hint:='To ReWind';
      SpeedForward.Hint:='To Forward';
      if not IsFullScreen then SpeedScreen.Hint:='To Reduice Screen'
      else SpeedScreen.Hint:='Full Screen';
      Label1.Caption:='When I''m Hide, just click with the'+#13+
                      'right button to see me back!';
    end;
  end;
end;


procedure TMyUAviPlayer.FormShow(Sender: TObject);
begin
  Feed;
  if FEnter then begin
    CheckButton(fBegin);
    FEnter:=False;
  end;
  FilterGraph1.Connect;
  with MyUAviPlayer2 do begin
    Video1.Visible:=False;
    Image1.Visible:=True;
    Show;
  end;
end;

procedure TMyUAviPlayer.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  with MyUAviPlayer2 do begin
    Close;
  end;
  with FilterGraph1 do begin
    TryStop;
    Disconnect;
  end;
  FEnter:=True;
end;

procedure TMyUAviPlayer.SpeedLoadClick(Sender: TObject);
begin
  if not CheckValidity(fLoad) then Exit;
  if OpenDialog1.Execute then begin
    with FilterGraph1 do begin
      TryStop;
    end;
    FFileName:=OpenDialog1.FileName;
    with MyUAviPlayer2 do begin
      Image1.Visible:=False;
      Video1.Visible:=True;
    end;
    with FilterGraph1 do begin
      ClearGraph;
      FilterGraph2.RenderFile(StringToOleStr(FFileName),nil);
      QueryInterfaces;
      DSTrackBar1.Position:=0;
    end;
    CheckButton(fLoad);
  end;
end;

procedure TMyUAviPlayer.SpeedPlayClick(Sender: TObject);
begin
  if not CheckValidity(fPlay) then Exit;
  if Assigned(FilterGraph1.MediaControl) then begin
    MyDoShow;
    FilterGraph1.MediaControl.Run;
    CheckButton(fPlay);
  end;
end;

procedure TMyUAviPlayer.SpeedScreenClick(Sender: TObject);
begin
  if not CheckValidity(fScreen) then Exit;
  if not IsFullScreen then begin
    MyUAviPlayer2.WindowState:=wsMaximized;
    IsFullScreen:=True;
  end
  else begin
    MyUAviPlayer2.WindowState:=wsNormal;
    IsFullScreen:=False;
  end;
  CheckButton(fScreen);
end;

procedure TMyUAviPlayer.MyMouseDown(FX,FY:Integer);
begin
  if Visible then begin
    Visible:=False;
  end
  else begin
    Visible:=True;
    Left:=MyUAviPlayer2.Left+FX-20;
    Top:=MyUAviPlayer2.Top+FY-20;
  end;
end;

procedure TMyUAviPlayer.TryStop;
begin
  with FilterGraph1 do begin
    if Assigned(MediaControl) then begin
      MediaControl.GetState(0,FState);
      if FState=State_Running then MediaControl.Stop;
    end;
    MyDoHide;
  end;
end;

procedure TMyUAviPlayer.SpeedPauseClick(Sender: TObject);
begin
  if not CheckValidity(fPause) then Exit;
  with FilterGraph1.MediaControl do begin
    GetState(0,FState);
    if FState=State_Paused then begin
      Run;
      CheckButton(fResume);
    end
    else begin
      Pause;
      CheckButton(fPause);
    end;
  end;
end;

function TMyUAviPlayer.CheckValidity(FButton:TMediaState):Boolean;
begin
//  TMediaState=(Pause,Play,Stop,Rewind,Forwind,Load,Screen);
  Result:=False;
  case FButton of
    fPause,fPlay,fStop,fRewind,fForwind,fScreen:begin
      if FFileName='' then Exit;
    end;
  end;
  with FilterGraph1 do begin
    case FButton of
      fPlay:begin
        if Assigned(MediaControl) then begin
          MediaControl.GetState(0,FState);
          if FState=State_Running then Exit;
        end;
      end;
      fStop:begin
        if Assigned(MediaControl) then begin
          MediaControl.GetState(0,FState);
          if FState=State_Stopped then Exit;
        end;
      end;
    end;
  end;
  Result:=True;
end;

procedure TMyUAviPlayer.CheckButton(FButton:TMediaState);
begin
  case FButton of
    fRewind:begin
      SpeedRewind.Enabled:=True;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=True;
      SpeedStop.Enabled:=True;
      SpeedForward.Enabled:=True;
      SpeedLoad.Enabled:=False;
      SpeedScreen.Enabled:=True;
    end;
    fPlay:begin
      SpeedRewind.Enabled:=True;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=True;
      SpeedStop.Enabled:=True;
      SpeedForward.Enabled:=True;
      SpeedLoad.Enabled:=False;
      SpeedScreen.Enabled:=True;
    end;
    fPause:begin
      SpeedRewind.Enabled:=False;
      SpeedPlay.Enabled:=False;
      SpeedPause.Enabled:=True;
      SpeedStop.Enabled:=False;
      SpeedForward.Enabled:=False;
      SpeedLoad.Enabled:=False;
      SpeedScreen.Enabled:=False;
    end;
    fStop:begin
      SpeedRewind.Enabled:=False;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=False;
      SpeedStop.Enabled:=True;
      SpeedForward.Enabled:=False;
      SpeedLoad.Enabled:=True;
      SpeedScreen.Enabled:=False;
    end;
    fForwind:begin
      SpeedRewind.Enabled:=True;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=True;
      SpeedStop.Enabled:=True;
      SpeedForward.Enabled:=True;
      SpeedLoad.Enabled:=False;
      SpeedScreen.Enabled:=True;
    end;
    fLoad:begin
      SpeedRewind.Enabled:=True;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=True;
      SpeedStop.Enabled:=True;
      SpeedForward.Enabled:=True;
      SpeedLoad.Enabled:=False;
      SpeedScreen.Enabled:=False;
    end;
    fBegin:begin
      SpeedRewind.Enabled:=False;
      SpeedPlay.Enabled:=False;
      SpeedPause.Enabled:=False;
      SpeedStop.Enabled:=False;
      SpeedForward.Enabled:=False;
      SpeedLoad.Enabled:=True;
      SpeedScreen.Enabled:=False;
    end;
    fEnd:begin
      SpeedRewind.Enabled:=False;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=False;
      SpeedStop.Enabled:=False;
      SpeedForward.Enabled:=False;
      SpeedLoad.Enabled:=True;
      SpeedScreen.Enabled:=False;
    end;
    fResume:begin
      SpeedRewind.Enabled:=True;
      SpeedPlay.Enabled:=True;
      SpeedPause.Enabled:=True;
      SpeedStop.Enabled:=True;
      SpeedForward.Enabled:=True;
      SpeedLoad.Enabled:=False;
      SpeedScreen.Enabled:=True;
    end;
  end;
end;


procedure TMyUAviPlayer.SpeedStopClick(Sender: TObject);
begin
  if not CheckValidity(fStop) then Exit;
  TryStop;
  CheckButton(fStop);
end;

procedure TMyUAviPlayer.MyDoShow;
begin
  with MyUAviPlayer2 do begin
    Video1.Align:=alClient;
    Video1.Visible:=True;
    Image1.Visible:=False;
  end;
end;

procedure TMyUAviPlayer.MyDoHide;
begin
  with MyUAviPlayer2 do begin
    Video1.Align:=alNone;
    Video1.Width:=1;
    Video1.Height:=1;
    Video1.Visible:=False;
    Image1.Visible:=True;
  end;
end;


procedure TMyUAviPlayer.Timer1Timer(Sender: TObject);
var
  fPosition,fDuration:Int64;
  APosition:Integer;
begin
  with FilterGraph1 do begin
    if Assigned(MediaSeeking) then begin
      MediaSeeking.GetCurrentPosition(fPosition);
      ShowPlayTime(Round(fPosition/10000000));
      MediaSeeking.GetDuration(fDuration);
      APosition:=(fPosition*100) div FDuration;
{      DSTrackBar1.Position:=APosition;}
    end;
  end;
end;

procedure TMyUAviPlayer.ShowPlayTime(FTime:Integer);
var
  AHour,AMinute:Integer;
begin
  AHour:=FTime div 3600;
  FTime:=FTime-AHour*3600;
  AMinute:=FTime div 60;
  FTime:=FTime-AMinute*60;
  LedControl1.Text:=Format('%.02d',[AHour]);
  LedControl2.Text:=Format('%.02d',[AMinute]);
  LedControl3.Text:=Format('%.02d',[FTime]);
  Application.ProcessMessages;
end;


procedure TMyUAviPlayer.FilterGraph1GraphComplete(sender: TComponent;
  Result: HRESULT; Renderer: IBaseFilter);
begin
  MyDoHide;
  DSTrackBar1.Position:=0;
  CheckButton(FBegin);
end;

procedure TMyUAviPlayer.SetLangue(FLan:Integer);
begin
  FLangue:=FLan;
  Feed;
end;

end.
