unit UAVIInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, MPlayer, StdCtrls, Buttons,MySource, Demande,UFonction;

const
  AviType:array[0..17] of String =('RIFF','AVIH','IART','ICMT','ICOP','INAM','IPRD',
                                   'ISBJ','ISRC','STRF','DISP','STRH','STRD','MOVI',
                                   'IDX1','JUNK','PRMI','LIST');
type
  TAviInfo=record
    Tags0:array[0..50] of String;
    Tags1,Tags2:array[0..50] of Integer;
    TagNum:Integer;
  end;
  TMyUAVIInfo = class(TForm)
    Panel1: TPanel;
    VideoPlayer1: TMediaPlayer;
    Panel3: TPanel;
    Animate1: TAnimate;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    GroupBox2: TGroupBox;
    Edit1: TEdit;
    SpeedButton3: TSpeedButton;
    GroupBox3: TGroupBox;
    Panel4: TPanel;
    Panel5: TPanel;
    SpeedButton2: TSpeedButton;
    GroupBox4: TGroupBox;
    Panel6: TPanel;
    GroupBox5: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Demande1: TDemande;
{    procedure FormCreate(Sender: TObject);}
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    TagInfo:TAviInfo;
    AWidth,AHeight:Integer;
    FLogicalPosition:Integer;
    FOld:Integer;
    FMicroCount:Integer;
    FFrScale:LongInt;
    AFileName:String;
    AStart,AEnd:Integer;
    AFirst:Boolean;
    AHeader:array[0..10000] of Char;
    AFile1:TFileStream;
    AJustOne:Boolean;
  public
    procedure DoUpDate;
    procedure ParseInfo;
    procedure FillStruct;
    function IsIn(FString:String):Boolean;
    procedure DoPlay;
    procedure DoCorrect;
    procedure SetTraking;
    procedure DoWaitPlay;
    procedure MyDoShow;
    procedure MyDoHide;
    procedure Feed;
  end;

var
  MyUAVIInfo: TMyUAVIInfo;

implementation

uses UPosition, UFrame;

{$R *.DFM}

procedure TMyUAVIInfo.SpeedButton1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  Panel2.Caption:=ExtractFileName(OpenDialog1.FileName);
  AFileName:=OpenDialog1.FileName;
  AJustOne:=True;
  DoUpDate;
  DoPlay;
  MyDoShow;
end;

procedure TMyUAVIInfo.DoUpDate;
begin
  ParseInfo;
  FillStruct;
end;

procedure TMyUAVIInfo.ParseInfo;
var
  AAdd,ABit:LongInt;
  ACod:array[0..200] of Char;
  ASiz:LongInt;
begin
  AFile1:=TFileStream.Create(AFileName,fmOpenRead or fmShareDenyNone);
  ABit:=0;
  TagInfo.TagNum:=0;
  try
    with AFile1 do begin
      if AJustOne then begin
        Read(AHeader,8196);
        Position:=0;
        AJustOne:=False;
      end;
      while ABit<AFile1.Size-1 do begin
        Read(ACod,4);
        ABit:=Position;
        AAdd:=Position;
        if IsIn(ACod) then begin
          Read(ASiz,SizeOf(ASiz));
          if MyUpper(ACod)='MOVI' then begin
            Position:=Position-12;
            Read(ASiz,SizeOf(ASiz));
            Position:=Position+ASiz;
          end;
          if MyUpper(ACod)='IDX1' then begin
            Position:=Position-4;
            Read(ASiz,SizeOf(ASiz));
            Position:=Position+ASiz;
          end;
          if MyUpper(ACod)='JUNK' then begin
            Position:=Position-4;
            Read(ASiz,SizeOf(ASiz));
            Position:=Position+ASiz;
          end;
          if MyUpper(ACod)='DISP' then begin
            Position:=Position-4;
            Read(ASiz,SizeOf(ASiz));
            Position:=Position+ASiz;
          end;
          TagInfo.Tags0[TagInfo.TagNum]:=MyUpper(ACod);
          TagInfo.Tags1[TagInfo.TagNum]:=AAdd+1;
          TagInfo.Tags2[TagInfo.TagNum]:=ASiz;
          TagInfo.TagNum:=TagInfo.TagNum+1;
        end
        else begin
          Position:=Position-3;
        end;
      end;
    end;
  except
    AFile1.Free;
  end;
  AFile1.Free;
  TagInfo.TagNum:=TagInfo.TagNum-1;
end;

function TMyUAVIInfo.IsIn(FString:String):Boolean;
var
  i1:Integer;
begin
  Result:=False;
  for i1:=0 to 17 do begin
    if MyUpper(FString)=AviType[i1] then Result:=True;
  end;
end;

procedure TMyUAVIInfo.FillStruct;
var
  idcnt:Integer;
  FLen,FLen1:LongInt;
  AStvl,ASmiffy:array[0..100] of Char;
  AScale:Double;
  AFactor:Double;
  ATotalFrame:Integer;
  ATotalTime:Double;
  APosition:Integer;
begin
//  ATotalFrame:=0;
  try
    AFile1:=TFileStream.Create(AFileName,fmOpenReadWrite or fmShareDenyNone);
    with TagInfo,AFile1 do begin
      for idcnt:=0 to TagNum do begin
        if Tags0[idcnt]='RIFF' then begin
        end;
        if Tags0[idcnt]='AVIH' then begin
          Position:=Position+Tags1[idcnt]+4-1;
          FMicroCount:=Position;
          Read(FLen,SizeOf(FLen));
//          ListBox1.Items.Add(Format('MicroSeconds per frame: %d',[FLen]));
          FOld:=FLen;
          Edit1.Text:=IntToStr(FOld);
          Read(FLen,SizeOf(FLen));
//          ListBox1.Items.Add(Format('Peak Bitrate: %d',[FLen]));
          Read(FLen,SizeOf(FLen));
          Read(FLen,SizeOf(FLen));
//          ListBox1.Items.Add(Format('Flags: %d',[FLen]));
          Read(FLen,SizeOf(FLen));
//          ListBox1.Items.Add(Format('Total Frames: %d',[FLen]));
          ATotalFrame:=FLen;
          Read(FLen,SizeOf(FLen));
//          ListBox1.Items.Add(Format('Initial frame: %d',[FLen]));
          Read(FLen,SizeOf(FLen));
//          ListBox1.Items.Add(Format('Streams (i.e. Video,Audio): %d',[FLen]));
          Read(FLen,SizeOf(FLen));
          Read(FLen,SizeOf(FLen));
          AWidth:=FLen;
          Read(FLen,SizeOf(FLen));
          AHeight:=FLen;
//          ListBox1.Items.Add(Format('Resolution: %d x %d',[AWidth,AHeight]));
          // holdflen and rate...
          Read(FLen,SizeOf(FLen));
          Read(FLen,SizeOf(FLen));
          // inconnu et length...
          Read(FLen,SizeOf(FLen));
          Read(FLen,SizeOf(FLen));
          Read(ASmiffy,4);
          // Length...
          Read(FLen,SizeOf(FLen));
        end;
        if Tags0[idcnt]='STRH' then begin
          Position:=Tags1[idcnt]+4-1;
          Read(AStvl,4);
          if MyUpper(AStvl)='VIDS' then begin
            Read(ASmiffy,4);
            Read(FLen,SizeOf(FLen));
            Read(FLen,SizeOf(FLen));
            Read(FLen,SizeOf(FLen));
            Read(FLen,SizeOf(FLen));
            Position:=Position-SizeOf(FLen);
            AFactor:=0;
            if (FLen<>10000) then AFactor:=10000 / FLen;
            FLen:=10000;
            Write(FLen,SizeOf(FLen));
            FFrScale:=FLen;
            FLogicalPosition:=Position;
            Read(FLen,SizeOf(FLen));
            if AFactor<>0 then begin
              Position:=Position-SizeOf(FLen);
              FLen1:=Round(FLen*AFactor);
              Write(FLen1,SizeOf(FLen1));
              FLen:=FLen1;
            end;
            FOld:=FLen;
            Edit1.Text:=IntToStr(FOld);
            AScale:=FLen / FFrScale;
//            ListBox1.Items.Add(Format('Frames per sec: %s',[DToS(AScale,4)]));
            ATotalTime:=ATotalFrame/AScale;
//            ListBox1.Items.Add(Format('Total time %s',[DToS(ATotalTime,4)]));
          end;
        end;
      end;
    end;
  except
    AFile1.Free;
  end;
  AFile1.Free;
end;

procedure TMyUAVIInfo.FormShow(Sender: TObject);
begin
  Feed;
  Edit1.Text:='';
  Panel4.Caption:='';
  Panel5.Caption:='';
  Panel6.Caption:='';
  AFirst:=False;
  MyDoHide;
end;

procedure TMyUAVIInfo.DoPlay;
begin
  with Animate1 do begin
    AutoSize:=False;
    Height:=AHeight;
    Width:=AWidth;
  end;
  with VideoPlayer1 do begin
    AFirst:=True;
    FileName:=AFileName;
    Open;
    SetTraking;
    Panel4.Caption:='0';
    Panel5.Caption:=IntToStr(Length);
    Panel6.Caption:=IntToStr(Length);
    AStart:=0;
    AEnd:=Length;
{    with TrackBar1 do begin
      Min:=0;
      Max:=Length;
    end;}
  end;
end;

procedure TMyUAVIInfo.Timer1Timer(Sender: TObject);
begin
  if (VideoPlayer1.Mode=mpStopped) and (AFirst) then begin
//    VideoPlayer1.Rewind;
//    VideoPlayer1.Position:=AStart;
    VideoPlayer1.StartPos:=AStart;
    VideoPlayer1.EndPos:=AEnd;
    DoWaitPlay;
//    VideoPlayer1.Play;
  end;

  if VideoPlayer1.Mode<>mpPlaying then Exit;
  Panel4.Caption:=IntToStr(VideoPlayer1.Position);
end;

procedure TMyUAVIInfo.SpeedButton2Click(Sender: TObject);
begin
  with VideoPlayer1 do begin
    Stop;
    MyUPosition.ShowModal;
    AStart:=StrToInt(MyUPosition.Edit1.Text);
    AEnd:=StrToInt(MyUPosition.Edit2.Text);
    StartPos:=AStart;
    EndPos:=AEnd;
    Panel5.Caption:=IntToStr(EndPos);
    DoWaitPlay;
  end;
end;

procedure TMyUAVIInfo.SpeedButton3Click(Sender: TObject);
begin
  with VideoPlayer1 do begin
    Close;
    MyUFrame.ShowModal;
    Edit1.Text:=MyUFrame.MaskEdit1.Text;
    DoCorrect;
    FileName:=AFileName;
    Open;
    SetTraking;
    Rewind;
    StartPos:=AStart;
    EndPos:=AEnd;
    DoWaitPlay;
{    Stop;
    StartPos:=AStart;
    EndPos:=AEnd;
    Play;}
  end;
end;

procedure TMyUAVIInfo.DoCorrect;
var
  FTemp1:LongInt;
  AMicroWave1:Double;
  AMicroWave2:LongInt;
  ARetour1,ARetour2:Integer;
begin
  AFile1:=TFileStream.Create(AFileName,fmOpenReadWrite or fmShareDenyNone);
  with AFile1 do begin
    Position:=FLogicalPosition;
    FTemp1:=StrToInt(Edit1.Text);
    ARetour1:=Write(FTemp1,SizeOf(FTemp1));
    Position:=FMicroCount;
    AMicroWave1:=1000000 /(FTemp1/FFrScale);
    AMicroWave2:=StrToInt(DToS(AMicroWave1,0));
    ARetour2:=Write(AMicroWave2,SizeOf(AMicroWave2));
    Free;
  end;
  DoUpDate;
end;

procedure TMyUAVIInfo.SetTraking;
begin
{  with TrackBar1 do begin
    Min:=0;
    Max:=VideoPlayer1.Length;
  end;}
end;

procedure TMyUAVIInfo.TrackBar1Change(Sender: TObject);
begin
  with VideoPlayer1 do begin
//    StartPos:=0;
//    EndPos:=Length;
{    Position:=TrackBar1.Position;}
  end;
end;

procedure TMyUAVIInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  VideoPlayer1.Close;
end;

procedure TMyUAVIInfo.DoWaitPlay;
begin
  VideoPlayer1.Play;
//  Wait(5000);
{  while VideoPlayer1.Mode=mpSeeking do
  begin
  end;}
end;

procedure TMyUAVIInfo.MyDoShow;
begin
  GroupBox2.Visible:=True;
  GroupBox3.Visible:=True;
  GroupBox4.Visible:=True;
  SpeedButton1.Enabled:=False;
end;

procedure TMyUAVIInfo.MyDoHide;
begin
  GroupBox2.Visible:=False;
  GroupBox3.Visible:=False;
  GroupBox4.Visible:=False;
  SpeedButton1.Enabled:=True;
end;

procedure TMyUAVIInfo.BitBtn1Click(Sender: TObject);
begin
  Close;
end;

procedure TMyUAVIInfo.BitBtn2Click(Sender: TObject);
begin
  with Demande1 do begin
    if GetOption2=0 then Msg:='Are you sure you want to restore the original rate ?'
    else Msg:='Etes-vous sur de vouloir restaurer le fichier comme avant ?';
    Buttons:=[mbYes,mbNo];
    if Execute=mrNo then begin
      Close;
      Exit;
    end;
  end;
  VideoPlayer1.Close;
  try
    AFile1:=TFileStream.Create(AFileName,fmOpenReadWrite or fmShareDenyNone);
    with AFile1 do begin
      Position:=0;
      Write(AHeader,8196);
      Free;
    end;
  except
  end;
  Close;
end;

procedure TMyUAviInfo.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To synchronize the AVI...';
      GroupBox1.Caption:=' Select the AVI ';
      GroupBox2.Caption:=' Frame Per Second ';
      GroupBox3.Caption:=' Frame From and To ';
      GroupBox4.Caption:=' Maximum Frame ';
      GroupBox5.Caption:=' Command ';
    end;
    1:begin
      Caption:='Pour synchroniser un AVI...';
      GroupBox1.Caption:=' Selectionner l''AVI ';
      GroupBox2.Caption:=' Image par seconde ';
      GroupBox3.Caption:=' Image de et  ';
      GroupBox4.Caption:=' Image Maximum ';
      GroupBox5.Caption:=' Commande ';
    end;
  end;
end;

end.
