unit UBatch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Demande,MySource,UFonction, Full, AviCutting;

type
  TMyUBatch = class(TForm)
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Demande1: TDemande;
    Full1: TFull;
    Full2: TFull;
    Full3: TFull;
    AviCutting1: TAviCutting;
    Full4: TFull;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FCommande:array[0..50] of String;
  public
    function ParseInfo(FString:String):Integer;
    procedure ClearFiles;
    procedure Start1(FString:String); //DivxAuto
    procedure Start2(FString:String); //m3Px3...
    procedure Start3(FString1,FString2:String); //Ac3Decoding...
    procedure Start4(FString1,FString2:String); //mpaDecoding...
    procedure Start5(FString1:String;FSize:Integer);// Normalize...
    procedure Start6(FString1,FString2,FString3:String;FSon:Integer); //Multiplex...
    procedure Feed;
    procedure CheckCutting(FPath:String);
    procedure EraseVobFile(FPath:String);
  end;

var
  MyUBatch: TMyUBatch;

implementation

uses UDecodeAc3, UNormaliser, UMultipler, UMp2ToWav;

{$R *.DFM}

procedure TMyUBatch.FormShow(Sender: TObject);
begin
  Feed;
  RadioButton1.Checked:=False;
  RadioButton2.Checked:=False;
end;

function TMyUBatch.ParseInfo(FString:String):Integer;
var
  i1:Integer;
  ACount:Integer;
begin
  ACount:=0;
  for i1:=1 to Length(FString) do begin
    if Copy(FString,i1,1)=' ' then begin
      FString[i1]:='*';
      Inc(ACount);
    end;
  end;
  Inc(ACount);
  for i1:=1 to ACount do begin
    FCommande[i1-1]:=UmLine(i1,FString);
  end;
  Result:=ACount;
end;


procedure TMyUBatch.BitBtn1Click(Sender: TObject);
var
  AFile1:String;
  i2,i1,AFirst:Integer;
  ALine4,ALine3,ALine1,ALine2:String;
  ALine5,ALine6,ALine7:String;
  ALieur1,ALieur2:String;
  ABeta1,ABeta2,ABeta3:String;
  ABrote1:String;
  ALineP:array[0..20] of String;
begin
  if (not RadioButton1.Checked) and
     (not RadioButton2.Checked) then begin
    with Demande1 do begin
      if GetOption2=0 then begin
        Msg:='You must select a line!'+#13+
             'Please correct before continuing...';
      end
      else begin
        Msg:='Vous devez slectionner une option!'+#13+
             'SVP, Corrigez avant de continuer...';
      end;
      ShowModal;
      Exit;
    end;
  end;
  ClearFiles;
  Full1.Clear;
  AFile1:=SlashSep(GetPath,'BATCH.NEO');
  Full1.LoadfromFile(AFile1);
  if (Full1.Count<=0) and
     (RadioButton2.Checked) then begin
    with Demande1 do begin
      if GetOption2=0 then begin
        Msg:='The batch file is empty!'+#13+
             'Nothing to do!';
      end
      else begin
        Msg:='Le fichier Batch est vide!'+#13+
             'Rien  faire!';
      end;
      ShowModal;
      Exit;
    end;
  end;
  if RadioButton1.Checked then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Are you sure to clear the batch file ?'
      else Msg:='Etes-vous sur de vouloir vider le fichier batch ?';
      Buttons:=[mbNo,mbYes];
      if Execute=mrNo then Exit;
      Full1.Clear;
      Full1.SaveToFile(AFile1);
      Close;
      Exit;
    end;
  end;
  // the rest is for the batch file!
  Full1.Clear;
  Full1.LoadFromFile(AFile1);
  AFirst:=(Full1.Count+1) div 7;
  Full2.Clear;
  for i1:=1 to AFirst do begin
    ALine1:=Full1.Strings[(i1-1)*7];
    ALine2:=Full1.Strings[(i1-1)*7+1];
    ALine3:=Full1.Strings[(i1-1)*7+2];
    ALine4:=Full1.Strings[(i1-1)*7+3];
    ALine5:=Full1.Strings[(i1-1)*7+4];
    ALine6:=Full1.Strings[(i1-1)*7+5];
    ALine7:=Full1.Strings[(i1-1)*7+6];
    Start1(ALine2);
    Start2(Format('"%s" %s',[SlashSep(GetPath,'m2apx3g.exe'),ALine1]));
    if GetOption7=1 then begin
      EraseVobFile(ALine7);
    end;
  end;
  for i1:=1 to AFirst do begin
    ALine1:=Full1.Strings[(i1-1)*7];
    ALine2:=Full1.Strings[(i1-1)*7+1];
    ALine3:=Full1.Strings[(i1-1)*7+2];
    ALine4:=Full1.Strings[(i1-1)*7+3];
    ALine5:=Full1.Strings[(i1-1)*7+4];
    ALine6:=Full1.Strings[(i1-1)*7+5];
    ALine7:=Full1.Strings[(i1-1)*7+6];
    if MyUpper(Copy(ALine6,1,3))<>'0XC' then begin
      Start3(SlashSep(ALine5,Format('Stream%s.AC3',[ALine6])),
             SlashSep(ALine5,Format('Stream%s.wav',[ALine6])));
    end
    else begin
      Start4(SlashSep(ALine5,Format('Stream%s.mpa',[ALine6])),
             SlashSep(ALine5,Format('Stream%s.wav',[ALine6])));
    end;
    if GetOption4=0 then begin
      RemoveFile(SlashSep(ALine5,Format('Stream%s.AC3',[ALine6])));
      RemoveFile(SlashSep(ALine5,Format('Stream%s.MPA',[ALine6])));
    end;
    ALieur2:=SlashSep(ALine5,Format('Stream%s.WAV',[ALine6]));
    Start5(ALieur2,StrToInt(ALine4));
    ABeta1:=SlashSep(ALine5,'MOVIE_1.AVI');
    ABeta2:=SlashSep(ALine5,Format('Stream%s.WAV',[ALine6]));
    ABeta3:=ALine5;
    Start6(ABeta1,ABeta2,ABeta3,StrToInt(ALine3));
    CheckCutting(ALine5);
  end;
  if GetOption5.Command=1 then DoCloseWindow;
  Close;
end;

procedure TMyUBatch.ClearFiles;
var
  i1:Integer;
  ALine1,ALine2:String;
begin
  with Full3 do begin
    Clear;
    ReadFiles(GetPath);
    for i1:=0 to Count-1 do begin
      ALine1:=ExtractFileExt(Strings[i1]);
      ALine2:=MyUpper(ALine1);
      if ALine2='.SYL' then begin
        RemoveFile(Strings[i1]);
      end;
    end;
  end;
end;

procedure TMyUBatch.Start1(FString:String); //DivxAuto
begin
  MyShellExecute2(SlashSep(GetPath,'DIVXAUTO40B.EXE'),FString);
end;

procedure TMyUBatch.Start2(FString:String); //m3Px3...
begin
  MyShellExecute(SlashSep(GetPath,'m2apx3g.exe'),FString);
end;

procedure TMyUBatch.Start3(FString1,FString2:String); //Ac3Decoding...
begin
  with MyUDecodeAC3 do begin
    ABetaLine1:=FString1;
    ABetaLine2:=FString2;
    ACommand:=True;
    ShowModal;
    ACommand:=False;
  end;
end;

procedure TMyUBatch.Start4(FString1,FString2:String); //mpaDecoding...
begin
  with MyUMp2ToWav do begin
    ABetaLine1:=FString1;
    ABetaLine2:=FString2;
    ACommand:=True;
    ShowModal;
    ACommand:=False;
  end;
end;

procedure TMyUBatch.Start5(FString1:String;FSize:Integer);// Normalize...
begin
  with MyUNormaliser do begin
    UpDown1.Position:=FSize;
    ABetaLine1:=FString1;
    ACommand:=True;
    ShowModal;
    ACommand:=False;
  end;
end;

procedure TMyUBatch.Start6(FString1,FString2,FString3:String;FSon:Integer); //Multiplex...
begin
  with MyUMultipler do begin
    MyCommande(FString1,FString2,FString3,FSon);
  end;
end;

procedure TMyUBatch.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='Batch Control';
      RadioGroup1.Caption:=' What do you want to do ? ';
      RadioButton1.Caption:='Clear the batch';
      RadioButton2.Caption:='Execute the batch';
      BitBtn2.Caption:='Cancel';
    end;
    1:begin
      Caption:='Contrle d''execution';
      RadioGroup1.Caption:=' Que voulez-vous faire ? ';
      RadioButton1.Caption:='Vider le batch';
      RadioButton2.Caption:='Executer le batch';
      BitBtn2.Caption:='Arrter';
    end;
  end;
end;

procedure TMyUBatch.CheckCutting(FPath:String);
var
  ALine1:String;
  ACD:Integer;
  ASize1:Integer;
  AInfo:TKFInfo;
begin
  if GetOption6=0 then Exit;
  ALine1:=SlashSep(FPath,'FILM.AVI');
  if GetOption3=0 then ACD:=640 else ACD:=690;
//  ACD:=5;
  ASize1:=FileSizer(ALine1) div (1024*1024);
  if ASize1<=ACD then Exit;
  with AviCutting1 do begin
    FileName:=ALine1;
    if not Execute then Exit;
    AInfo:=GetNearKF(TotalFrame div 2);
    if (AInfo.First=-1) or (AInfo.Second=-1) then Exit;
    CreateSyl(ALine1,SlashSep(FPath,'FILM1.AVI'),
              SlashSep(FPath,'FILM2.AVI'),
              SlashSep(GetPath,'TEMP1.SYL'),
              SlashSep(GetPath,'TEMP2.SYL'),AInfo);
    ExecuteSyl(GetPath);
  end;
  if GetOption4=0 then begin
    RemoveFile(ALine1);
  end;
end;

procedure TMyUBatch.EraseVobFile(FPath:String);
var
  i1:Integer;
  ALine1:String;
begin
//  ShowMessage(FPath);
  Full4.Clear;
  Full4.ReadFiles(ExtractFilePath(FPath));
  for i1:=0 to Full4.Count-1 do begin
    ALine1:=MyUpper(ExtractFileExt(Full4.Strings[i1]));
    if ALine1='.VOB' then begin
      RemoveFile(Full4.Strings[i1]);
    end;
  end;
end;





end.
