unit UDecodeAc3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Advgauge, StdCtrls, Buttons, ExtCtrls, Demande, MySource,
  ShellApi,UFonction,Full, DosOutPut;

type
  TMyUDecodeAc3 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Edit1: TEdit;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Demande1: TDemande;
    Panel4: TPanel;
    Panel5: TPanel;
    AdvGauge1: TAdvGauge;
    OuputDos1: TOuputDos;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure OuputDos1Data(Sender: TOuputDos; Buffer: Pointer;
      Size: Integer);
    procedure OuputDos1ErrorData(Sender: TOuputDos; Buffer: Pointer;
      Size: Integer);
    procedure OuputDos1Terminated(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    ABetaLine1,ABetaLine2:String;
    AFirst:Boolean;
    ACommand:Boolean;
  public
    procedure MyCommande(FString1,FString2:String;FFrom:Boolean=False);
    procedure AddToCommande(FFull:TFull;FString1,FString2:String);
    function GetSubLine(FString:String):Integer;
    function TreadPath(FString:String):String;
    procedure Feed;
  end;

var
  MyUDecodeAc3: TMyUDecodeAc3;

implementation

{$R *.DFM}

procedure TMyUDecodeAc3.FormShow(Sender: TObject);
begin
  Panel1.Cursor:=crDefault;
  Panel2.Cursor:=crDefault;
  Panel3.Cursor:=crDefault;
  Panel4.Cursor:=crDefault;
  Panel5.Cursor:=crDefault;
  AdvGauge1.Cursor:=crDefault;
  Edit1.Cursor:=crDefault;
  Edit2.Cursor:=crDefault;
  Cursor:=crDefault;
  Feed;
  AFirst:=False;
  Edit1.Text:='';
  Edit2.Text:='';
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=True;
  Panel5.Caption:='';
  SpeedButton1.Enabled:=True;
  SpeedButton2.Enabled:=True;
  AdvGauge1.Prepare(0,100);
  AFirst:=True;
end;

procedure TMyUDecodeAc3.BitBtn2Click(Sender: TObject);
begin
  if OuputDos1.Running then OuputDos1.Terminate(0);
  Close;
end;

procedure TMyUDecodeAc3.BitBtn1Click(Sender: TObject);
begin
  if not FileExists(Edit1.Text) then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Please select the files to convert!'
      else Msg:='SVP, slectionnez le fichier  convertir';
      ShowModal;
      Exit;
    end;
  end;
  if Edit2.Text='' then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='Please select the output wav name.'
      else Msg:='SVP, Slectionnez le fichier de sortie WAV.';
      ShowModal;
      Exit;
    end;
  end;
  if AnsiPos(' ',ExtractFileName(Edit2.Text))<>0 then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='The output file must not have a blank in the name or extension!'
      else Msg:='Le fichier de sortie ne peut avoir de blanc dans le nom ou l''extension!';
      ShowModal;
      Exit;
    end;
  end;
  BitBtn1.Enabled:=False;
  SpeedButton1.Enabled:=False;
  SpeedButton2.Enabled:=False;
  MyCommande(Edit1.Text,Edit2.Text,True);
end;

procedure TMyUDecodeAC3.MyCommande(FString1,FString2:String;FFrom:Boolean);
var
  FName1,FName2:String;
begin
  Panel1.Cursor:=crHourGlass;
  Panel2.Cursor:=crHourGlass;
  Panel3.Cursor:=crHourGlass;
  Panel4.Cursor:=crHourGlass;
  Panel5.Cursor:=crHourGlass;
  AdvGauge1.Cursor:=crHourGlass;
  Edit1.Cursor:=crHourGlass;
  Edit2.Cursor:=crHourGlass;
  Cursor:=crHourGlass;
  FString1:=TreadPath(FString1);
  FString2:=TreadPath(FString2);
  if not FFrom then begin
    Show;
    BitBtn1.Enabled:=False;
    BitBtn2.Enabled:=False;
    SpeedButton1.Enabled:=False;
    SpeedButton2.Enabled:=False;
    Application.ProcessMessages;
  end;
  FName1:=SlashSep(ExtractFilePath(Application.ExeName),'AZID.EXE');
  FName2:=Format('%s %s',[FString1,FString2]);
  with OuputDos1 do begin
    Prepare;
    CommandLine:=Format('%s %s',[FName1,FName2]);
    Execute;
  end;
end;

procedure TMyUDecodeAC3.AddToCommande(FFull:TFull;FString1,FString2:String);
var
  FName1,FName2:String;
begin
  FName1:=SlashSep(ExtractFilePath(Application.ExeName),'AZID.EXE');
  FName2:=Format('%s %s',[FString1,FString2]);
  FFull.Add(Format('"%s" %s',[FName1,FName2]));
end;

procedure TMyUDecodeAc3.SpeedButton1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMyUDecodeAc3.SpeedButton2Click(Sender: TObject);
var
  ALine1,ALine2:String;
begin
  if not SaveDialog1.Execute then Exit;
  ALine1:=SaveDialog1.FileName;
  ALine2:=ChangeFileExt(ALine1,'.WAV');
  Edit2.Text:=ALine2;
end;

procedure TMyUDecodeAc3.OuputDos1Data(Sender: TOuputDos; Buffer: Pointer;
  Size: Integer);
begin
  Panel5.Caption:=OuputDos1.GetLine(Buffer,Size);
  GetSubLine(Panel5.Caption);
  Application.ProcessMessages;
end;

procedure TMyUDecodeAc3.OuputDos1ErrorData(Sender: TOuputDos;
  Buffer: Pointer; Size: Integer);
begin
  Panel5.Caption:=OuputDos1.GetLine(Buffer,Size);
  GetSubLine(Panel5.Caption);
  Application.ProcessMessages;
end;

procedure TMyUDecodeAc3.OuputDos1Terminated(Sender: TObject);
begin
  if OuputDos1.Running then OuputDos1.Terminate(0);
  Close;
end;

function TMyUDecodeAC3.GetSubLine(FString:String):Integer;
var
  NAFirst:Boolean;
  APos,i1:Integer;
  ALine1,ALine2,ALine3:String;
  ALine4,ALine5,ALine6:String;
  ANombre1:Integer;
begin
  Result:=0;
  try
    NAFirst:=True;
    APos:=-1;
    for i1:=Length(FString) downto 1 do begin
      if (FString[i1]='[') and (NAFirst) then begin
        NAFirst:=False;
        APos:=i1;
      end;
    end;
    if APos<>-1 then begin
      ALine1:=CopyToEnd(FString,APos+1);
      APos:=AnsiPos(']',ALine1);
      if APos<>0 then begin
        ALine2:=Copy(ALine1,1,APos-1);
        APos:=AnsiPos('%',ALine2);
        if APos<>0 then begin
          ALine3:=Copy(ALine2,1,APos-1);
          ALine4:=TrimRight(ALine3);
          ALine5:=TrimLeft(ALine4);
          APos:=AnsiPos('.',ALine5);
          if APos<>0 then begin
            ALine6:=Copy(ALine5,1,APos-1);
            ANombre1:=StrToIntDef(ALine6,-1);
            if ANombre1<>-1 then begin
              AdvGauge1.MoveTo(ANombre1);
            end;
          end;
        end;
      end;
    end;
  except
  end;
end;


procedure TMyUDecodeAc3.Timer1Timer(Sender: TObject);
begin
  if not AFirst then Exit;
  if not ACommand then Exit;
  AFirst:=False;
  MyCommande(ABetaLine1,ABetaLine2);
end;

procedure TMyUDecodeAc3.FormCreate(Sender: TObject);
begin
  ACommand:=False;
end;

function TMyUDecodeAc3.TreadPath(FString:String):String;
var
  ALine1,ALine2:String;
begin
  ALine1:=ExtractFilePath(FString);
  ALine2:=ExtractShortPathName(ALine1);
  Result:=SlashSep(ALine2,ExtractFileName(FString));
end;

procedure TMyUDecodeAC3.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To decode an AC3 to WAV';
      Panel2.Caption:='Select the AC3 file';
      Panel3.Caption:='Select the Wav output file';
      BitBtn1.Caption:='Encode';
      BitBtn2.Caption:='Cancel';
    end;
    1:begin
      Caption:='Pour dcoder un AC3 vers un WAV';
      Panel2.Caption:='Selectionner le fichier AC3';
      Panel3.Caption:='Selectionner le fichier de sortie WAV';
      BitBtn1.Caption:='Encoder';
      BitBtn2.Caption:='Arrter';
    end;
  end;
end;




end.
