unit UExtractAudio;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Demande, IfoInfo, StdCtrls, Buttons, ExtCtrls, CheckLst,VStrip,
  ComCtrls, Full,VStrip_Thread, FolderBrowse,FileCtrl,MySource,UFonction;

type
  TStreamInfo = record
    save      : Byte;
    remap_to  : Byte;
  end;
  TAStreamInfo = array[0..511] of TStreamInfo; // 0..255 streams, 256..511 substreams
  TIFOProgramChain = record
    NumCells  : Integer;
    Length    : t_vs_time;
    Cells     : TPAVobCellID;
  end;
  TOutputInfo = record
    FileName  : string;
    FileSize  : Cardinal; // split
    Flags     : Cardinal;
  end;
  TMyUExtractAudio = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    BitBtn1: TBitBtn;
    OpenDialog1: TOpenDialog;
    IfoInfo1: TIfoInfo;
    Demande1: TDemande;
    CheckListBox1: TCheckListBox;
    BitBtn2: TBitBtn;
    Panel6: TPanel;
    SpeedButton2: TSpeedButton;
    Panel7: TPanel;
    Edit2: TEdit;
    OpenDialog2: TOpenDialog;
    ListViewFiles: TListView;
    Full1: TFull;
    Panel8: TPanel;
    ListViewInfo: TListView;
    ProgressBar1: TProgressBar;
    Panel9: TPanel;
    SpeedButton3: TSpeedButton;
    Panel10: TPanel;
    Edit3: TEdit;
    FolderBrowse1: TFolderBrowse;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    output_mask: Byte;
    IFOChains: array of TIFOProgramChain;
    cell_list: TPAVobCellID;
    outputs: array[0..inb_MAX_OUTPUT - 1] of TOutputInfo;
    num_output, cur_output: Integer;
    IFOChainIdx: Integer;
    KeepCells: array[0..255, 0..255, 0..1] of Boolean; // 0 display, 1 keep
    num_cell: Integer;
    streams, substreams: ta_vs_streamflags;
    stream_info: TAStreamInfo;
    VSThreadActive:Boolean;
    VSThread: TVSThread;
    data: t_vs_data;
    NumIFOChains: Integer;
    stream_ofs: Integer;
  public
    procedure DoClear;
    procedure MyDoShow;
    procedure MyDoHide;
    procedure DoExtract(FLangue,FDirectory:String);
    procedure OnVSThreadTerminate(Sender: TObject);
    function GetFileName(FLangue,FDirectory:String):String;
    procedure Feed;
  end;

var
  MyUExtractAudio: TMyUExtractAudio;

implementation

{$R *.DFM}

procedure TMyUExtractAudio.SpeedButton1Click(Sender: TObject);
var
  i1:Integer;
begin
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
  with IfoInfo1 do begin
    FileName:=Edit1.Text;
    if not Execute then begin
      with Demande1 do begin
        if GetOption2=0 then Msg:='A error occured when reading the IFO file!'
        else Msg:='Une Erreur s''est produite pendant la lecture du fichier IFO!';
        ShowModal;
      end;
      DoClear;
      Exit;
    end;
    Panel4.Caption:=FileLength;
    for i1:=0 to AudioList.Count-1 do begin
      CheckListBox1.Items.Add(AudioList.Strings[i1]);
    end;
  end;
end;

procedure TMyUExtractAudio.DoClear;
begin
  Edit1.Text:='';
  CheckListBox1.Items.Clear;
  Panel4.Caption:='';
  Edit2.Text:='';
  ListViewInfo.Items.Clear;
  Edit3.Text:='';
end;

procedure TMyUExtractAudio.FormShow(Sender: TObject);
begin
  Feed;
  DoClear;
  MyDoShow;
end;

procedure TMyUExtractAudio.MyDoShow;
begin
  BitBtn1.Enabled:=False;
  BitBtn2.Enabled:=True;
  SpeedButton1.Enabled:=True;
  SpeedButton2.Enabled:=True;
  SpeedButton3.Enabled:=True;
end;

procedure TMyUExtractAudio.MyDoHide;
begin
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=False;
  SpeedButton1.Enabled:=False;
  SpeedButton2.Enabled:=False;
  SpeedButton3.Enabled:=False;
end;

procedure TMyUExtractAudio.BitBtn2Click(Sender: TObject);
var
  i1:Integer;
  ACount:Integer;
  APos:Integer;
  ALine2,ALangue,ALine1:String;
begin
  ACount:=0;
  APos:=-1;
  for i1:=0 to CheckListBox1.Items.Count-1 do begin
    if CheckListBox1.Checked[i1]=True then begin
      Inc(ACount);
      APos:=i1;
    end;
  end;
  if ACount>1 then begin
    with Demande1 do begin
      if GetOption2=0 then begin
        Msg:='You can''t select more than 1 audio to extract!'+#13+
             'Please correct before continuing!';
      end
      else begin
        Msg:='Vous ne pouvez pas slectionner plus qu''1 piste audio!'+#13+
             'Veuillez corriger avant de continuer!';
      end;
      ShowModal;
      Exit;
    end;
  end;
  if APos<0 then begin
    with Demande1 do begin
      if GetOption2=0 then begin
        Msg:='You must select at least one audio file to extract!'+#13+
             'Please correct before continuing!';
      end
      else begin
        Msg:='Vous devez slectionner une piste audio  extraire!'+#13+
             'Veuillez corriger avant de continuer!';
      end;
      ShowModal;
      Exit;
    end;
  end;
  if (Edit3.Text='') or (not DirectoryExists(Edit3.Text)) then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='You must select a directory where to go!'
      else Msg:='Vous devez slectionner un rpertoire de sortie!';
      ShowModal;
      Exit;
    end;
  end;
  MyDoHide;
  ListViewInfo.Items.Clear;
  ALine1:=CheckListBox1.Items.Strings[APos];
  ALine2:=Copy(ALine1,Length(ALine1)-4,4);
  ALangue:=ALine2;
  DoExtract(ALangue,Edit3.Text);
end;

procedure TMyUExtractAudio.DoExtract(FLangue:String;FDirectory:String);
var
  i, j, k, ai: Integer;
  total_lba: Cardinal;
  VSThreadActive:Boolean;
  List:TStringList;
  i1:Integer;
  Item:TListItem;
  ACount:Integer;
  FFileName:String;
begin
  NumIFOChains := 0;
  IFOChainIdx := -1;
  stream_ofs := 0;
  output_mask := $01;
  num_cell := 0;
  cell_list := nil;

  VSThread := nil;
  VSThreadActive := False;

  num_output := 0;
  cur_output := 0;

  List:=TStringList.Create;
  if ((not VSThreadActive) and (VSThread = nil)) then begin
    VSThreadActive := True;
    data.infile := CreateStreamList(ListViewFiles, total_lba);
    FFileName:=GetFileName(FLangue,FDirectory);
    StrLCopy(data.outputs[0].outfile,PChar(FFileName),Length(FFileName));
    data.outputs[0].split_output:=0;
    data.outputs[0].flags:=vso_DEMUX;
    data.num_outputs:=1;
    data.flags := 0;
    data.framerate := $ffffffff;
    data.aspectratio := $ffffffff;
    data.flags:=data.flags+vs_USE_ASPI;

    data.max_sync_bytes:=2048;
    data.start_lba:=0;
    data.end_lba:=$ffffffff;

    ai := 1;

    for i := 0 to 255 do begin
      stream_info[i].save := $ff;
      stream_info[i].remap_to := i;
      stream_info[i + 256].save := $ff;
      stream_info[i + 256].remap_to := i;
      stream_info[i].save := stream_info[i].save and (not output_mask);
      stream_info[i + 256].save := stream_info[i + 256].save and (not output_mask);
    end;
    ACount:=0;
    for i1:=0 to 255 do begin
      if FLangue=Format('0x%.2x',[i1]) then ACount:=i1;
    end;
    stream_info[256+ACount].save:=output_mask;


    for i := 0 to 255 do begin
      streams[i].remap_to := stream_info[i].remap_to;
      streams[i].user_func := 0;
      streams[i].save := stream_info[i].save;
      substreams[i].remap_to := stream_info[i + 256].remap_to;
      substreams[i].user_func := 0;
      substreams[i].save := stream_info[i + 256].save;
    end;
    VSThread := TVSThread.CreateVS(@data, @streams, @substreams, total_lba, num_cell, cell_list, ProgressBar1, ListViewInfo, ListViewFiles);
    VSThread.OnTerminate := OnVSThreadTerminate;
    VSThread.Suspended := False;
  end else if ((VSThread <> nil) and VSThreadActive) then
    VSThread.Terminate();
end;

procedure TMyUExtractAudio.SpeedButton2Click(Sender: TObject);
var
  i1:Integer;
  Items:TListItem;
begin
  if not OpenDialog2.Execute then Exit;
  Edit2.Text:=OpenDialog2.FileName;
  ListViewFiles.Items.Clear;
  Full1.Clear;
  Full1.LoadFromFile(Edit2.Text);
  for i1:=0 to Full1.Count-1 do begin
    Items:=ListViewFiles.Items.Add;
    Items.Caption:=Full1.Strings[i1];
  end;
end;


procedure TMyUExtractAudio.OnVSThreadTerminate(Sender: TObject);
begin
  // these are *not* needed anymore, as vs_done was definitely called!
  try
    if (data.infile <> nil) then begin
      FreeMem(data.infile);
      data.infile := nil;
    end;
    if (cell_list <> nil) then begin
      FreeMem(cell_list);
      cell_list := nil;
      num_cell := 0;
    end;
    VSThread := nil;
    VSThreadActive := False;
    MyDoShow;
  except
  end;
end;



procedure TMyUExtractAudio.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
  i:Integer;
begin
  if ((VSThread <> nil) and VSThreadActive) then begin
    VSThread.Terminate();
    VSThread.WaitFor();
  end;
  for i := 0 to NumIFOChains - 1 do
    if (IFOChains[i].Cells <> NiL) then begin
      FreeMem(IFOChains[i].Cells);
      IFOChains[i].Cells := Nil;
    end;
  SetLength(IFOChains, 0);
  NumIFOChains := 0;
{  if (ASPIOk) then
    aspi_Done();}
end;

procedure TMyUExtractAudio.SpeedButton3Click(Sender: TObject);
begin
  if not FolderBrowse1.Execute then Exit;
  Edit3.Text:=FolderBrowse1.Directory;
end;

function TMyUExtractAudio.GetFileName(FLangue,FDirectory:String):String;
begin
  if MyUpper(Copy(FLangue,1,3))<>'0XC' then begin
    Result:=SlashSep(FDirectory,Format('Stream%s.AC3',[FLangue]));
  end
  else begin
    Result:=SlashSep(FDirectory,Format('Stream%s.MPA',[FLangue]));
  end;
end;

procedure TMyUExtractAudio.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='To Extract Audio From Vob Files.';
      Panel2.Caption:='Select the IFO File:';
      Panel7.Caption:='Select the LST File:';
      Panel10.Caption:='Select the Output Path:';
      BitBtn1.Caption:='Cancel';
    end;
    1:begin
      Caption:='Pour Extraire l''audio de fichiers VOB';
      Panel2.Caption:='Selectionnez le fichier IFO:';
      Panel7.Caption:='Selectionnez le fichier LST:';
      Panel10.Caption:='Selectionnez le rpertoire de sortie:';
      BitBtn1.Caption:='Arrter';
    end;
  end;
end;


procedure TMyUExtractAudio.BitBtn1Click(Sender: TObject);
begin
  try
    VSThread.Terminate();
    VSThread.WaitFor();
  except
  end;
  Close;
end;

end.
