unit USelector;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Full, Demande, StdCtrls, Buttons,MySource, IfoInfo,ShellApi,
  FolderBrowse,UFonction, DosOutPut, AviCutting;

type
  TMyUSelector = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Edit2: TEdit;
    Panel5: TPanel;
    ComboBox1: TComboBox;
    Panel6: TPanel;
    ComboBox2: TComboBox;
    Panel7: TPanel;
    Edit3: TEdit;
    Panel8: TPanel;
    Panel9: TPanel;
    Edit5: TEdit;
    SpeedButton3: TSpeedButton;
    Panel10: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Demande1: TDemande;
    Full1: TFull;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    Panel11: TPanel;
    Panel12: TPanel;
    Panel13: TPanel;
    ComboBox3: TComboBox;
    IfoInfo1: TIfoInfo;
    FolderBrowse1: TFolderBrowse;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    OuputDos1: TOuputDos;
    Full2: TFull;
    Full3: TFull;
    AviCutting1: TAviCutting;
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FPath:String;
    FCommande:array[0..50] of String;
  public
    procedure DoClear;
    function CheckValidity:Boolean;
    function CheckOutPut(FPath:String):Boolean;
    function CheckSpace(FPath:String):Boolean;
    function GetBitrate(FCD:Integer):Integer;
    function GetSubLine(FInteger:Integer):String;
    procedure TreadPath;
    procedure Feed;
    procedure CheckCutting;
  end;

var
  MyUSelector: TMyUSelector;

implementation

uses UDecodeAc3, UNormaliser, UMultipler, UMp2ToWav;

{$R *.DFM}

procedure TMyUSelector.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key=VK_ESCAPE then begin
    Close;
    Exit;
  end;
end;

procedure TMyUSelector.FormShow(Sender: TObject);
begin
  Feed;
  FPath:=ExtractFilePath(Application.ExeName);
  DoClear;
end;

procedure TMyUSelector.DoClear;
begin
  Edit1.Text:='';
  Edit2.Text:='';
  ComboBox1.Items.Clear;
  Edit3.Text:='';
  Edit5.Text:='';
  BitBtn1.Enabled:=True;
  BitBtn2.Enabled:=True;
  ComboBox2.ItemIndex:=1;
  Panel12.Caption:='';
end;

procedure TMyUSelector.SpeedButton1Click(Sender: TObject);
var
  i1:Integer;
begin
  ComboBox1.Items.Clear;
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
  with IFOInfo1 do begin
    FileName:=Edit1.Text;
    Execute;
    Panel12.Caption:=FileLength;
    if TimeLength>110*60 then ComboBox3.ItemIndex:=1
    else ComboBox3.ItemIndex:=0;
    for i1:=0 to AudioList.Count-1 do begin
      ComboBox1.Items.Add(AudioList.Strings[i1]);
    end;
    ComboBox1.ItemIndex:=0;
  end;
end;

procedure TMyUSelector.SpeedButton2Click(Sender: TObject);
begin
  if not OpenDialog2.Execute then Exit;
  Edit2.Text:=OpenDialog2.FileName;
end;

procedure TMyUSelector.SpeedButton3Click(Sender: TObject);
begin
  if not FolderBrowse1.Execute then Exit;
  Edit5.Text:=FolderBrowse1.Directory;
end;

procedure TMyUSelector.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TMyUSelector.BitBtn1Click(Sender: TObject);
var
  APath:String;
  ABitrate:Integer;
  ALine1,ALine2,ALine3:String;
begin
  if not CheckValidity then Exit;
  if not CheckOutPut(Edit5.Text) then Exit;
  TreadPath;

  ABitrate:=GetBitrate(ComboBox3.ItemIndex);

  MyShellExecute2(SlashSep(GetPath,'DIVXAUTO.EXE'),Format('L 10 100 %d',[ABitrate]));
  ALine1:='-b '+Edit2.Text+GetSubLine(ComboBox2.ItemIndex);

  ALine2:=ComboBox1.Items.Strings[ComboBox1.ItemIndex];
  ALine3:=Copy(ALine2,Length(ALine2)-4,4);
  ALine1:=ALine1+' -a'+ALine3+' -o8 '+Edit5.Text;

  if StrToIntDef(Edit3.Text,-1)>0 then begin
    ALine1:=ALine1+' -# 0 '+Edit3.Text;
  end;

  MyShellExecute(SlashSep(GetPath,'m2apx3g.exe'),ALine1);
  if GetOption5.Encode=1 then DoCloseWindow;
  Close;
end;

procedure TMyUSelector.BitBtn3Click(Sender: TObject);
var
  APath:String;
  ABitrate:Integer;
  ALine1,ALine2,ALine3:String;
  ALangue:String;
  ABeta1,ABeta2,ABeta3:String;
  ALineP1:String;
begin
  if not CheckValidity then Exit;
  if not CheckOutPut(Edit5.Text) then Exit;
  if not CheckSpace(Edit5.Text) then Exit;
  TreadPath;

  ABitrate:=GetBitrate(ComboBox3.ItemIndex);

  Full1.Clear;
  Full1.Add(Format('start %s L 10 100 %d',[SlashSep(FPath,'divxauto.exe'),ABitrate]));
  ALine1:='-b '+Edit2.Text;

  ALine1:=ALine1+GetSubLine(ComboBox2.ItemIndex);


  ALine2:=ComboBox1.Items.Strings[ComboBox1.ItemIndex];
  ALine3:=Copy(ALine2,Length(ALine2)-4,4);
  ALangue:=ALine3;
  ALine1:=ALine1+' -a'+ALine3+' -o8 '+Edit5.Text;

  if StrToIntDef(Edit3.Text,-1)>0 then begin
    ALine1:=ALine1+' -# 0 '+Edit3.Text;
  end;

  ALineP1:=Format('L 10 100 %d',[ABitrate]);

  MyShellExecute2(SlashSep(GetPath,'DIVXAUTO.EXE'),ALineP1);
  MyShellExecute(SlashSep(GetPath,'m2apx3g.exe'),ALine1);

  if MyUpper(Copy(ALangue,1,3))<>'0XC' then begin
    ALine1:=SlashSep(Edit5.Text,Format('Stream%s.ac3',[ALangue]));
    ALine2:=SlashSep(Edit5.Text,Format('Stream%s.wav',[ALangue]));
    with MyUDecodeAC3 do begin
      ABetaLine1:=ALine1;
      ABetaLine2:=ALine2;
      ACommand:=True;
      ShowModal;
      ACommand:=False;
    end;
  end
  else begin
    ALine1:=SlashSep(Edit5.Text,Format('Stream%s.mpa',[ALangue]));
    ALine2:=SlashSep(Edit5.Text,Format('Stream%s.wav',[ALangue]));
    with MyUMp2ToWav do begin
      ABetaLine1:=ALine1;
      ABetaLine2:=ALine2;
      ACommand:=True;
      ShowModal;
      ACommand:=False;
    end;
  end;
  if GetOption4=0 then begin
    RemoveFile(SlashSep(Edit5.Text,Format('Stream%s.AC3',[ALangue])));
    RemoveFile(SlashSep(Edit5.Text,Format('Stream%s.MPA',[ALangue])));
  end;
  with MyUNormaliser do begin
    UpDown1.Position:=188;
    ABetaLine1:=ALine2;
    ACommand:=True;
    ShowModal;
    ACommand:=False;
  end;
  ABeta1:=SlashSep(Edit5.Text,'Movie_1.avi');
  ABeta2:=SlashSep(Edit5.Text,Format('Stream%s.wav',[ALangue]));
  ABeta3:=Edit5.Text;
  MyUMultipler.MyCommande(ABeta1,ABeta2,ABeta3,0);
  CheckCutting;
  if GetOption5.Batch=1 then DoCloseWindow;
  Close;
end;

procedure TMyUSelector.BitBtn4Click(Sender: TObject);
var
  AFile1:String;
  APath:String;
  ABitrate:Integer;
  ALine1,ALine2,ALine3:String;
  ALangue:String;
  AGine1:String;
  ASeba1,ASeba2:String;
begin
{save to bach file}
  if not CheckValidity then Exit;
  if not CheckOutPut(Edit5.Text) then Exit;
  TreadPath;
  ABitrate:=GetBitrate(ComboBox3.ItemIndex);
  APath:=Edit5.Text;
  Full1.Clear;
  Full1.Add(Format('start %s L 10 100 %d',[SlashSep(FPath,'divxauto.exe'),ABitrate]));
  AGine1:=Format('L 10 100 %d',[ABitrate]);
  ALine1:='-b '+Edit2.Text;
  ASeba2:=GetSpeedFile;
  ASeba1:=' '+ASeba2+' ';
  case ComboBox2.ItemIndex of
    0:ALine1:=ALine1+' -f2 -q0'+ASeba1+'-1 720 576 -3Y 576';
    1:ALine1:=ALine1+' -f2 -q0'+ASeba1+'-1 720 416 -3Y 416';
    2:ALine1:=ALine1+' -f2 -q0'+ASeba1+'-1 720 320 -3Y 416';
    3:ALine1:=ALine1+' -f0 -q0'+ASeba1+'-s4 -1 720 480 -3Y 480';
    4:ALine1:=ALine1+' -f0 -q0'+ASeba1+'-s4 -1 720 416 -3Y 416';
    5:ALine1:=ALine1+' -f0 -q0'+ASeba1+'-s4 -1 720 320 -3Y 416';
  end;

  ALine2:=ComboBox1.Items.Strings[ComboBox1.ItemIndex];
  ALine3:=Copy(ALine2,Length(ALine2)-4,4);
  ALangue:=ALine3;
  ALine1:=ALine1+' -a'+ALine3+' -o8 '+APath;

  if StrToIntDef(Edit3.Text,-1)>0 then begin
    ALine1:=ALine1+' -# 0 '+Edit3.Text;
  end;
  AFile1:=SlashSep(GetPath,'Batch.Neo');
  with Full1 do begin
    Clear;
    LoadFromFile(AFile1);
    Add(ALine1);
    Add(AGine1);
    Add('0');
    Add('188');
    Add(Edit5.Text);
    Add(ALangue);
    SaveToFile(AFile1);
  end;
  Close;
end;

function TMyUSelector.CheckValidity:Boolean;
begin
  Result:=False;
  with Demande1 do begin
    if Edit1.Text='' then begin
      if GetOption2=0 then Msg:='Please Select the IFO file before processing...'
      else Msg:='SVP, selectionnez le fichier IFO avant de continuer...';
      ShowModal;
      Exit;
    end;
    if Edit2.Text='' then begin
      if GetOption2=0 then Msg:='Please Select the LST file before processing...'
      else Msg:='SVP, Slectionnez le fichier LST avant de continuer...';
      ShowModal;
      Exit;
    end;
    if ComboBox1.Items.Count<=0 then begin
      Msg:='Please Select the IFO file before processing...';
      ShowModal;
      Exit;
    end;
    if Edit5.Text='' then begin
      Msg:='Please Select the output directory before processing...';
      ShowModal;
      Exit;
    end;
  end;
  Result:=True;
end;

function TMyUSelector.CheckOutPut(FPath:String):Boolean;
var
  i1:Integer;
begin
  Result:=False;
  Full1.Clear;
  Full1.ReadFiles(FPath);
  if Full1.Count<>0 then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='The output path is not empty. if you process, files could be erase!'+#13+
                                'Do you want to continue anyway ?'
      else Msg:='Le rpertoire de sortie n''est pas vide. Si vous continuez, les fichiers seront effacs!'+#13+
                'Voulez-vous tout de mme continuer ?';
      Buttons:=[mbYes,mbNo];
      if Execute=mrNo then Exit;
    end;
  end;
{  for i1:=0 to Full1.Count-1 do begin
    RemoveFile(Full1.Strings[i1]);
  end;}
  Result:=True;
end;

function TMyUSelector.GetBitrate(FCD:Integer):Integer;
var
  ACD:Integer;
begin
  if GetOption3=0 then ACD:=640
  else ACD:=690;
  if FCD=0 then Result:=((ACD*8*1024) div (IFOInfo1.TimeLength))-64
  else Result:=((ACD*2*8*1024) div (IFOInfo1.TimeLength))-64;
end;

function TMyUSelector.GetSubLine(FInteger:Integer):String;
var
  ALine1:String;
  ASeba1,ASeba2:String;
begin
  ASeba2:=GetSpeedFile;
  ASeba1:=' '+ASeba2+' ';
  ALine1:='';
  case FInteger of
    0:ALine1:=ALine1+' -f2 -q0'+ASeba1+'-1 720 576 -3Y 576';
    1:ALine1:=ALine1+' -f2 -q0'+ASeba1+'-1 720 416 -3Y 416';
    2:ALine1:=ALine1+' -f2 -q0'+ASeba1+'-1 720 320 -3Y 416';
    3:ALine1:=ALine1+' -f0 -q0'+ASeba1+'-s4 -1 720 480 -3Y 480';
    4:ALine1:=ALine1+' -f0 -q0'+ASeba1+'-s4 -1 720 416 -3Y 416';
    5:ALine1:=ALine1+' -f0 -q0'+ASeba1+'-s4 -1 720 320 -3Y 416';
  end;
  Result:=ALine1;
end;

procedure TMyUSelector.TreadPath;
var
  i1:Integer;
begin
  Full2.Clear;
  Full2.LoadFromFile(Edit2.Text);
  Full3.Clear;
  for i1:=0 to Full2.Count-1 do begin
    Full3.Add(ExtractShortPathName(Full2.Strings[i1]));
  end;
  Full3.SaveToFile(Edit2.Text);
  Edit2.Text:=ExtractShortPathName(Edit2.Text);
  Edit5.Text:=ExtractShortPathName(Edit5.Text);
end;

procedure TMyUSelector.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='Parameter Selector';
      Panel2.Caption:='IFO Selector';
      Panel11.Caption:='Film Length';
      Panel4.Caption:='LST Selector';
      Panel5.Caption:='Sound Selector';
      Panel6.Caption:='Video Selector';
      Panel13.Caption:='CD Number';
      Panel7.Caption:='To Number Frame';
      Panel9.Caption:='Output Folder';
      BitBtn1.Caption:='Encode';
      BitBtn3.Caption:='Batch Command';
      BitBtn4.Caption:='Save To Batch File';
      BitBtn2.Caption:='Cancel';
    end;
    1:begin
      Caption:='Selecteur de Parametres';
      Panel2.Caption:='Selection de IFO';
      Panel11.Caption:='Longueur du film';
      Panel4.Caption:='Selection de LST';
      Panel5.Caption:='Selection du son';
      Panel6.Caption:='Selection Video';
      Panel13.Caption:='Nombre de CD';
      Panel7.Caption:='Image de fin';
      Panel9.Caption:='Repertoire de sortie';
      BitBtn1.Caption:='Encoder';
      BitBtn3.Caption:='Crer tout';
      BitBtn4.Caption:='Sauver dans le batch';
      BitBtn2.Caption:='Arrter';
    end;
  end;
end;

procedure TMyUSelector.CheckCutting;
var
  ALine1:String;
  ACD:Integer;
  ASize1:Integer;
  AInfo:TKFInfo;
begin
  if GetOption6=0 then Exit;
  ALine1:=SlashSep(Edit5.Text,'FILM.AVI');
  if GetOption3=0 then ACD:=640 else ACD:=690;
  ASize1:=(FileSizer(ALine1) div (1024*1024))+1;
  if ASize1<=ACD then Exit;
  with AviCutting1 do begin
    FileName:=ALine1;
    if not Execute then Exit;
    AInfo:=GetNearKF(TotalFrame div 2);
    if (AInfo.First=-1) or (AInfo.Second=-1) then Exit;
    CreateSyl(ALine1,SlashSep(Edit5.Text,'FILM1.AVI'),
              SlashSep(Edit5.Text,'FILM2.AVI'),
              SlashSep(GetPath,'TEMP1.SYL'),
              SlashSep(GetPath,'TEMP2.SYL'),AInfo);
    ExecuteSyl(GetPath);
  end;
  if GetOption4=0 then begin
    RemoveFile(ALine1);
  end;
end;

function TMyUSelector.CheckSpace(FPath:String):Boolean;
var
  AType1,AType2:Integer;
  ATotal1:Integer;
  ADisk:Integer;
  ATemp1:String;
  AFree1,AFree2:Integer;
begin
  Result:=True;
  if (StrToIntDef(Edit3.Text,-1)>0) and
     (StrToIntDef(Edit3.Text,-1)<20000) then Exit;
  if GetOption4=0 then Exit;
  if ComboBox3.ItemIndex=0 then AType1:=1
  else AType1:=2;
  if GetOption3=0 then AType2:=640
  else AType2:=690;
  ATotal1:=AType2*AType1;
  ATemp1:=MyUpper(FPath[1]);
  ADisk:=Ord(ATemp1[1])-64;
  AFree1:=DiskFree(ADisk);
  AFree2:=AFree1-(1200000000+ATotal1*3);
  if GetOption6=1 then begin
    AFree2:=AFree2-(ATotal1);
  end;
  if (AFree2<100000000) then begin
    with Demande1 do begin
      case GetOption2 of
        0:begin
          Msg:='The place is may be to short to encode a divx.'+#13+
               'Do you want to continue anyway ?';
        end;
        1:begin
          Msg:='La place restant peut tre insuffisante pour encoder un divx!'+#13+
               'Voulez vous toutefois continuer ?';
        end;
      end;
      Buttons:=[mbYes,mbNo];
      if Execute=mrNo then begin
        Result:=False;
        Exit;
      end;
    end;
  end;
  Result:=True;
end;




end.
