unit UTesteur;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MySource,UFonction, StdCtrls, DosOutPut, FolderBrowse, IfoInfo, Full,
  Demande, Buttons, ExtCtrls;

const
  TTestType:array[0..4] of String=('-r0','-r1','-r2','-r3','-r4');
type
  TTestRecord=record
    Time:Integer;
    Good:Boolean;
  end;
  TMyUTesteur = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    Panel4: TPanel;
    Edit2: TEdit;
    Panel8: TPanel;
    SpeedButton3: TSpeedButton;
    Panel9: TPanel;
    Edit5: TEdit;
    Panel10: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Demande1: TDemande;
    Full1: TFull;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenDialog2: TOpenDialog;
    IfoInfo1: TIfoInfo;
    FolderBrowse1: TFolderBrowse;
    OuputDos1: TOuputDos;
    Full2: TFull;
    Full3: TFull;
    CheckBox1: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FTesteur:array[0..10] of TTestRecord;
    AMem:String;
  public
    procedure Feed;
    function CheckOutPut(FPath:String):Boolean;
    function CheckValidity:Boolean;
    procedure TreadPath;
    function GetSubLine(FInteger:Integer):String;
    procedure DoPerformeTest(FString:String;ATest:Integer);
    procedure DoEraseFile(FPath:String);
    function DoCountFile(FPath:String):Integer;
  end;

var
  MyUTesteur: TMyUTesteur;

implementation

{$R *.DFM}

procedure TMyUTesteur.Feed;
begin
  case GetOption2 of
    0:begin
      Caption:='Speed Testing';
      Panel2.Caption:='IFO Selector';
      Panel4.Caption:='LST Selector';
      Panel9.Caption:='Output Directory';
      BitBtn1.Caption:='Test!';
      BitBtn2.Caption:='Cancel';
      CheckBox1.Caption:='Reset the default!';
    end;
    1:begin
      Caption:='Testeur de rapidit';
      Panel2.Caption:='Selectionnez le fichier IFO';
      Panel4.Caption:='Selectionnez le fichier LST';
      Panel9.Caption:='Selectionnez le rpertoire de Test';
      BitBtn1.Caption:='Testez!';
      BitBtn2.Caption:='Arrter';
      CheckBox1.Caption:='Remettre comme avant!';
    end;
  end;
end;

procedure TMyUTesteur.FormShow(Sender: TObject);
begin
  Feed;
  with Demande1 do begin
    case GetOption2 of
      0:begin
        Msg:='Ok. This is the test speed of your computer!'+#13+
             'If you have any problems with the test,'+#13+
             'You can replace the test by the default speed'+#13+
             'by clicking on Reset the Default and Cancel.'+#13+
             'NeoDivx will replace all the stuff like before!'+#13;
      end;
      1:begin
        Msg:='Ok. C''est le module test de rapidit  l''encodage!'+#13+
             'Si vous avez des problmes avec ce test,'+#13+
             'Vous pouvez remplacer les valeurs par dfaut,'+#13+
             'en cliquant sur Remettre comme avant puis Arrter!'+#13+
             'Ainsi, Neodivx remettra tout par dfaut!';
      end;
    end;
    ShowModal;
  end;
  Edit1.Text:='';
  Edit2.Text:='';
  Edit5.Text:='';
  CheckBox1.Checked:=False;
end;

procedure TMyUTesteur.BitBtn2Click(Sender: TObject);
begin
  if CheckBox1.Checked then begin
    SetSpeedFile('-r1');
  end;
  Close;
end;

procedure TMyUTesteur.SpeedButton1Click(Sender: TObject);
begin
  if not OpenDialog1.Execute then Exit;
  Edit1.Text:=OpenDialog1.FileName;
end;

procedure TMyUTesteur.SpeedButton2Click(Sender: TObject);
begin
  if not OpenDialog2.Execute then Exit;
  Edit2.Text:=OpenDialog2.FileName;
end;

procedure TMyUTesteur.SpeedButton3Click(Sender: TObject);
begin
  if not FolderBrowse1.Execute then Exit;
  Edit5.Text:=FolderBrowse1.Directory;
end;

function TMyUTesteur.CheckValidity:Boolean;
begin
  Result:=False;
  with Demande1 do begin
    if Edit1.Text='' then begin
      if GetOption2=0 then Msg:='Please Select the IFO file before processing...'
      else Msg:='SVP, selectionnez le fichier IFO avant de continuer...';
      ShowModal;
      Exit;
    end;
    if Edit2.Text='' then begin
      if GetOption2=0 then Msg:='Please Select the LST file before processing...'
      else Msg:='SVP, Slectionnez le fichier LST avant de continuer...';
      ShowModal;
      Exit;
    end;
    if Edit5.Text='' then begin
      Msg:='Please Select the output directory before processing...';
      ShowModal;
      Exit;
    end;
  end;
  Result:=True;
end;

function TMyUTesteur.CheckOutPut(FPath:String):Boolean;
var
  i1:Integer;
begin
  Result:=False;
  Full1.Clear;
  Full1.ReadFiles(FPath);
  if Full1.Count<>0 then begin
    with Demande1 do begin
      if GetOption2=0 then Msg:='The output path is not empty. if you process, files could be erase!'+#13+
                                'Do you want to continue anyway ?'
      else Msg:='Le rpertoire de sortie n''est pas vide. Si vous continuez, les fichiers seront effacs!'+#13+
                'Voulez-vous tout de mme continuer ?';
      Buttons:=[mbYes,mbNo];
      if Execute=mrNo then Exit;
    end;
  end;
  DoEraseFile(FPath);
  Result:=True;
end;

procedure TMyUTesteur.TreadPath;
var
  i1:Integer;
begin
  Full2.Clear;
  Full2.LoadFromFile(Edit2.Text);
  Full3.Clear;
  for i1:=0 to Full2.Count-1 do begin
    Full3.Add(ExtractShortPathName(Full2.Strings[i1]));
  end;
  Full3.SaveToFile(Edit2.Text);
  Edit2.Text:=ExtractShortPathName(Edit2.Text);
  Edit5.Text:=ExtractShortPathName(Edit5.Text);
end;

function TMyUTesteur.GetSubLine(FInteger:Integer):String;
var
  ALine1:String;
begin
  ALine1:='';
  case FInteger of
    0:ALine1:=ALine1+' -f2 -q0 -1 720 576 -3Y 576';
    1:ALine1:=ALine1+' -f2 -q0 -1 720 416 -3Y 416';
    2:ALine1:=ALine1+' -f2 -q0 -1 720 320 -3Y 416';
    3:ALine1:=ALine1+' -f0 -q0 -s4 -1 720 480 -3Y 480';
    4:ALine1:=ALine1+' -f0 -q0 -s4 -1 720 416 -3Y 416';
    5:ALine1:=ALine1+' -f0 -q0 -s4 -1 720 320 -3Y 416';
  end;
  Result:=ALine1;
end;


procedure TMyUTesteur.BitBtn1Click(Sender: TObject);
var
  ALine1:String;
  i1:Integer;
  ABest1,ABest2:Integer;
begin
  if not CheckValidity then Exit;
  if not CheckOutPut(Edit5.Text) then Exit;
  TreadPath;

  with Demande1 do begin
    if GetOption2=0 then begin
      Msg:='Ok. The test will begin. Don''t be afraid if NeoDivx'+#13+
           'will crach!. This is normal. We test the Maximum'+#13+
           'test and somethings, it''s crach!'+#13+
           'If this happens, just reset the default setting!';
    end
    else begin
      Msg:='Ok. Le test va commencer. Ne soyez pas effray si Neodivx'+#13+
           'se plante. C''est normal. Nous testons la puissance'+#13+
           'Maximum de votre pc et quelque fois, nous allons trop loin!'+#13+
           'Si cela devait arriver, remettez le paramtre par dfaut!';
    end;
    ShowModal;
  end;

  ALine1:='-b '+Edit2.Text+GetSubLine(0);

  ALine1:=ALine1+' -# 0 300';
  AMem:=ALine1+' -o8 '+Edit5.Text;

//  MyShellExecute(SlashSep(GetPath,'m2apx3g.exe'),ALine1);

  for i1:=0 to 4 do begin
    DoPerformeTest(TTestType[i1],i1);
  end;
  ABest1:=1000000;
  ABest2:=-1;
  for i1:=0 to 4 do begin
    if FTesteur[i1].Good then begin
      if FTesteur[i1].Time<ABest1 then begin
        ABest1:=FTesteur[i1].Time;
        ABest2:=i1;
      end;
    end;
  end;
  if ABest2<0 then begin
    with Demande1 do begin
      if GetOption2=0 then begin
        Msg:='The test did not work!';
      end
      else begin
        Msg:='Le test n''a pas march!';
      end;
      ShowModal;
      Close;
      Exit;
    end;
  end;
  with Demande1 do begin
    if GetOption2=0 then begin
      Msg:='The best test was the '+IntToStr(ABest2)+#13+
           'Do you want to keep the setting of the test ?';
    end
    else begin
      Msg:='Le meilleur test porte le numro '+IntToStr(ABest2)+'.'+#13+
           'Voulez-vous garder cet paramtre ?';
    end;
    Buttons:=[mbYes,mbNo];
    if Execute=mrNo then begin
      Close;
      Exit;
    end;
  end;
  SetSpeedFile(TTestType[ABest2]);
  with Demande1 do begin
    if GetOption2=0 then begin
      Msg:='Setting Save!';
    end
    else begin
      Msg:='Paramtres sauvegards!';
    end;
    ShowModal;
  end;
  Close;
end;

procedure TMyUTesteur.DoPerformeTest(FString:String;ATest:Integer);
var
  ABegin:Integer;
  ALine1:String;
  ARetour:TShellReturn;
  exitCode:DWORD;
begin
  try
    DoEraseFile(Edit5.Text);
    FTesteur[ATest].Good:=True;
    ABegin:=GetTickCount;
    ARetour:=MyShellExecute3(SlashSep(GetPath,'DIVXAUTO40B'),GetDivxAuto(10,100,6000));
    ALine1:=AMem+' '+FString+' ';
    MyShellExecute(SlashSep(GetPath,'m2apx3g.exe'),ALine1);
    FTesteur[ATest].Time:=Integer(GetTickCount)-ABegin;
    GetExitCodeProcess(ARetour.Shell.hProcess,exitcode);
    if exitcode=STILL_ACTIVE then begin
      FTesteur[ATest].Good:=False;
      FTesteur[ATest].Time:=-1;
      TerminateProcess(ARetour.Shell.hProcess,exitcode);
//    CloseHandle(ARetour.Shell.hProcess);
    end;
    DoEraseFile(Edit5.Text);
//    ShowMessage(Format('[%s][%d]',[FString,FTesteur[ATest].Time]));
  except
    FTesteur[ATest].Good:=False;
  end;
end;

procedure TMyUTesteur.DoEraseFile;
var
  i1:Integer;
begin
  Full1.Clear;
  Full1.ReadFiles(FPath);
  for i1:=0 to Full1.Count-1 do begin
//    RemoveFile(Full1.Strings[i1]);
  end;
end;

function TMyUTesteur.DoCountFile(FPath:String):Integer;
var
  i1:Integer;
begin
  Full1.Clear;
  Full1.ReadFiles(FPath);
  Result:=Full1.Count;
end;




end.
